searchData={"items":[{"type":"module","title":"GoogleApi.ServiceNetworking.V1","doc":"API client metadata for GoogleApi.ServiceNetworking.V1.","ref":"GoogleApi.ServiceNetworking.V1.html"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.discovery_revision/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Api.Operations","doc":"API calls for all endpoints tagged `Operations`.","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_cancel/4","doc":"Starts asynchronous cancellation on a long-running operation. The server makes a best effort to cancel the operation, but success is not guaranteed. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`. Clients can use Operations.GetOperation or other methods to check whether the cancellation succeeded or whether the operation completed despite cancellation. On successful cancellation, the operation is not deleted; instead, it becomes an operation with an Operation.error value with a google.rpc.Status.code of 1, corresponding to `Code.CANCELLED`.","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_cancel/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_cancel/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be cancelled.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_cancel/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_cancel/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_cancel/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_delete/4","doc":"Deletes a long-running operation. This method indicates that the client is no longer interested in the operation result. It does not cancel the operation. If the server doesn't support this method, it returns `google.rpc.Code.UNIMPLEMENTED`.","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_delete/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_delete/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_get/4","doc":"Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service.","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_get/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_get/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_get/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_get/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_list/4","doc":"Lists operations that match the specified filter in the request. If the server doesn't support this method, it returns `UNIMPLEMENTED`.","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_list/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_list/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The name of the operation's parent resource.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:filter` (*type:* `String.t`) - The standard list filter.\n    *   `:pageSize` (*type:* `integer()`) - The standard list page size.\n    *   `:pageToken` (*type:* `String.t`) - The standard list page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Operations.servicenetworking_operations_list/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Operations.html#servicenetworking_operations_list/4-returns"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Api.Services","doc":"API calls for all endpoints tagged `Services`.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_add_subnetwork/4","doc":"For service producers, provisions a new subnet in a peered service's shared VPC network in the requested region and with the requested size that's expressed as a CIDR range (number of leading bits of ipV4 network mask). The method checks against the assigned allocated ranges to find a non-conflicting IP address range. The method will reuse a subnet if subsequent calls contain the same subnet name, region, and prefix length. This method will make producer's tenant project to be a shared VPC service project as needed.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_add_subnetwork/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_add_subnetwork/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. A tenant project in the service producer organization, in the following format: services/{service}/{collection-id}/{resource-id}. {collection-id} is the cloud resource collection type that represents the tenant project. Only `projects` are supported. {resource-id} is the tenant project numeric id, such as `123456`. {service} the name of the peering service, such as `service-peering.example.com`. This service must already be enabled in the service consumer's project.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_add_subnetwork/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_add_subnetwork/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_add_subnetwork/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_create/4","doc":"Creates a private connection that establishes a VPC Network Peering connection to a VPC network in the service producer's organization. The administrator of the service consumer's VPC network invokes this method. The administrator must assign one or more allocated IP ranges for provisioning subnetworks in the service producer's VPC network. This connection is used for all supported services in the service producer's organization, so it only needs to be invoked once.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_create/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_create/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Connection.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_create/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_create/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_delete_connection/4","doc":"Deletes a private service access connection.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_delete_connection/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_delete_connection/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The private service connection that connects to a service producer organization. The name includes both the private service name and the VPC network peering name in the format of `services/{peering_service_name}/connections/{vpc_peering_name}`. For Google services that support this functionality, this is `services/servicenetworking.googleapis.com/connections/servicenetworking-googleapis-com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_delete_connection/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_delete_connection/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_delete_connection/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_list/4","doc":"List the private connections that are configured in a service consumer's VPC network.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_list/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_list/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`. If you specify `services/-` as the parameter value, all configured peering services are listed.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:network` (*type:* `String.t`) - The name of service consumer's VPC network that's connected with service producer network through a private connection. The network name must be in the following format: `projects/{project}/global/networks/{network}`. {project} is a project number, such as in `12345` that includes the VPC service consumer's VPC network. {network} is the name of the service consumer's VPC network.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_list/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_list/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_patch/4","doc":"Updates the allocated ranges that are assigned to a connection.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_patch/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_patch/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - The private service connection that connects to a service producer organization. The name includes both the private service name and the VPC network peering name in the format of `services/{peering_service_name}/connections/{vpc_peering_name}`. For Google services that support this functionality, this is `services/servicenetworking.googleapis.com/connections/servicenetworking-googleapis-com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:force` (*type:* `boolean()`) - If a previously defined allocated range is removed, force flag must be set to true.\n    *   `:updateMask` (*type:* `String.t`) - The update mask. If this is omitted, it defaults to \"*\". You can only update the listed peering ranges.\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Connection.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_connections_patch/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_connections_patch/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_disable_vpc_service_controls/4","doc":"Disables VPC service controls for a connection.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_disable_vpc_service_controls/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_disable_vpc_service_controls/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_disable_vpc_service_controls/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_disable_vpc_service_controls/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_disable_vpc_service_controls/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_add/4","doc":"Service producers can use this method to add DNS record sets to private DNS zones in the shared producer host project.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_add/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_add/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_add/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_add/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_add/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_get/4","doc":"Producers can use this method to retrieve information about the DNS record set added to the private zone inside the shared tenant host project associated with a consumer network.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_get/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_get/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. Parent resource identifying the connection which owns this collection of DNS zones in the format services/{service}.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:consumerNetwork` (*type:* `String.t`) - Required. The consumer network containing the record set. Must be in the form of projects/{project}/global/networks/{network}\n    *   `:domain` (*type:* `String.t`) - Required. The domain name of the zone containing the recordset.\n    *   `:type` (*type:* `String.t`) - Required. RecordSet Type eg. type='A'. See the list of [Supported DNS Types](https://cloud.google.com/dns/records/json-record).\n    *   `:zone` (*type:* `String.t`) - Required. The name of the zone containing the record set.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_get/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_get/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_list/4","doc":"Producers can use this method to retrieve a list of available DNS RecordSets available inside the private zone on the tenant host project accessible from their network.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_list/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_list/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:consumerNetwork` (*type:* `String.t`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is the project number, as in '12345' {network} is the network name.\n    *   `:zone` (*type:* `String.t`) - Required. The name of the private DNS zone in the shared producer host project from which the record set will be removed.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_list/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_list/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_remove/4","doc":"Service producers can use this method to remove DNS record sets from private DNS zones in the shared producer host project.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_remove/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_remove/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_remove/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_remove/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_remove/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_update/4","doc":"Service producers can use this method to update DNS record sets from private DNS zones in the shared producer host project.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_update/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_update/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_update/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_record_sets_update/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_record_sets_update/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_zones_add/4","doc":"Service producers can use this method to add private DNS zones in the shared producer host project and matching peering zones in the consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_zones_add/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_zones_add/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_zones_add/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_zones_add/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_zones_add/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_zones_remove/4","doc":"Service producers can use this method to remove private DNS zones in the shared producer host project and matching peering zones in the consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_zones_remove/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_zones_remove/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_zones_remove/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_dns_zones_remove/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_dns_zones_remove/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_enable_vpc_service_controls/4","doc":"Enables VPC service controls for a connection.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_enable_vpc_service_controls/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_enable_vpc_service_controls/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - The service that is managing peering connectivity for a service producer's organization. For Google services that support this functionality, this value is `services/servicenetworking.googleapis.com`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_enable_vpc_service_controls/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_enable_vpc_service_controls/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_enable_vpc_service_controls/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_dns_zones_get/4","doc":"Service producers can use this method to retrieve a DNS zone in the shared producer host project and the matching peering zones in consumer project","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_dns_zones_get/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_dns_zones_get/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The network that the consumer is using to connect with services. Must be in the form of services/{service}/projects/{project}/global/networks/{network}/zones/{zoneName} Where {service} is the peering service that is managing connectivity for the service producer's organization. For Google services that support this {project} is the project number, as in '12345' {network} is the network name. {zoneName} is the DNS zone name\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_dns_zones_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_dns_zones_get/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_dns_zones_get/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_dns_zones_list/4","doc":"* Service producers can use this method to retrieve a list of available DNS zones in the shared producer host project and the matching peering zones in the consumer project. *","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_dns_zones_list/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_dns_zones_list/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. Parent resource identifying the connection which owns this collection of DNS zones in the format services/{service}/projects/{project}/global/networks/{network} Service: The service that is managing connectivity for the service producer's organization. For Google services that support this functionality, this value is `servicenetworking.googleapis.com`. Projects: the consumer project containing the consumer network. Network: The consumer network accessible from the tenant project.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_dns_zones_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_dns_zones_list/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_dns_zones_list/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_get/4","doc":"Service producers use this method to get the configuration of their connection including the import/export of custom routes and subnetwork routes with public IP.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_get/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_get/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Name of the consumer config to retrieve in the format: `services/{service}/projects/{project}/global/networks/{network}`. {service} is the peering service that is managing connectivity for the service producer's organization. For Google services that support this functionality, this value is `servicenetworking.googleapis.com`. {project} is a project number e.g. `12345` that contains the service consumer's VPC network. {network} is the name of the service consumer's VPC network.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:includeUsedIpRanges` (*type:* `boolean()`) - Optional. When true, include the used IP ranges as part of the GetConsumerConfig output. This includes routes created inside the service networking network, consumer network, peers of the consumer network, and reserved ranges inside the service networking network. By default, this is false\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_get/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_get/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_get_vpc_service_controls/4","doc":"Consumers use this method to find out the state of VPC Service Controls. The controls could be enabled or disabled for a connection.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_get_vpc_service_controls/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_get_vpc_service_controls/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. Name of the VPC Service Controls config to retrieve in the format: `services/{service}/projects/{project}/global/networks/{network}`. {service} is the peering service that is managing connectivity for the service producer's organization. For Google services that support this functionality, this value is `servicenetworking.googleapis.com`. {project} is a project number e.g. `12345` that contains the service consumer's VPC network. {network} is the name of the service consumer's VPC network.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_get_vpc_service_controls/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_get_vpc_service_controls/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_get_vpc_service_controls/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_create/4","doc":"Creates a peered DNS domain which sends requests for records in given namespace originating in the service producer VPC network to the consumer VPC network to be resolved.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_create/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_create/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. Parent resource identifying the connection for which the peered DNS domain will be created in the format: `services/{service}/projects/{project}/global/networks/{network}` {service} is the peering service that is managing connectivity for the service producer's organization. For Google services that support this functionality, this value is `servicenetworking.googleapis.com`. {project} is the number of the project that contains the service consumer's VPC network e.g. `12345`. {network} is the name of the service consumer's VPC network.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_create/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_create/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_delete/4","doc":"Deletes a peered DNS domain.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_delete/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_delete/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `name` (*type:* `String.t`) - Required. The name of the peered DNS domain to delete in the format: `services/{service}/projects/{project}/global/networks/{network}/peeredDnsDomains/{name}`. {service} is the peering service that is managing connectivity for the service producer's organization. For Google services that support this functionality, this value is `servicenetworking.googleapis.com`. {project} is the number of the project that contains the service consumer's VPC network e.g. `12345`. {network} is the name of the service consumer's VPC network. {name} is the name of the peered DNS domain.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_delete/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_delete/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_list/4","doc":"Lists peered DNS domains for a connection.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_list/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_list/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. Parent resource identifying the connection which owns this collection of peered DNS domains in the format: `services/{service}/projects/{project}/global/networks/{network}`. {service} is the peering service that is managing connectivity for the service producer's organization. For Google services that support this functionality, this value is `servicenetworking.googleapis.com`. {project} is a project number e.g. `12345` that contains the service consumer's VPC network. {network} is the name of the service consumer's VPC network.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_peered_dns_domains_list/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_peered_dns_domains_list/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_update_consumer_config/4","doc":"Service producers use this method to update the configuration of their connection including the import/export of custom routes and subnetwork routes with public IP.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_update_consumer_config/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_update_consumer_config/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. Parent resource identifying the connection for which the consumer config is being updated in the format: `services/{service}/projects/{project}/global/networks/{network}` {service} is the peering service that is managing connectivity for the service producer's organization. For Google services that support this functionality, this value is `servicenetworking.googleapis.com`. {project} is the number of the project that contains the service consumer's VPC network e.g. `12345`. {network} is the name of the service consumer's VPC network.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_update_consumer_config/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_projects_global_networks_update_consumer_config/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_projects_global_networks_update_consumer_config/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_roles_add/4","doc":"Service producers can use this method to add roles in the shared VPC host project. Each role is bound to the provided member. Each role must be selected from within an allowlisted set of roles. Each role is applied at only the granularity specified in the allowlist.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_roles_add/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_roles_add/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. This is in a form services/{service} where {service} is the name of the private access management service. For example 'service-peering.example.com'.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_roles_add/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_roles_add/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_roles_add/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_search_range/4","doc":"Service producers can use this method to find a currently unused range within consumer allocated ranges. This returned range is not reserved, and not guaranteed to remain unused. It will validate previously provided allocated ranges, find non-conflicting sub-range of requested size (expressed in number of leading bits of ipv4 network mask, as in CIDR range notation).","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_search_range/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_search_range/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. This is in a form services/{service}. {service} the name of the private access management service, for example 'service-peering.example.com'.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_search_range/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_search_range/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.Operation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_search_range/4-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_validate/4","doc":"Service producers use this method to validate if the consumer provided network, project and requested range are valid. This allows them to use a fail-fast mechanism for consumer requests, and not have to wait for AddSubnetwork operation completion to determine if user request is invalid.","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_validate/4"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_validate/4","doc":"*   `connection` (*type:* `GoogleApi.ServiceNetworking.V1.Connection.t`) - Connection to server\n*   `parent` (*type:* `String.t`) - Required. This is in a form services/{service} where {service} is the name of the private access management service. For example 'service-peering.example.com'.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_validate/4-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Api.Services.servicenetworking_services_validate/4","doc":"*   `{:ok, %GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.ServiceNetworking.V1.Api.Services.html#servicenetworking_services_validate/4-returns"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Connection","doc":"Handle Tesla connections for GoogleApi.ServiceNetworking.V1.","ref":"GoogleApi.ServiceNetworking.V1.Connection.html"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.ServiceNetworking.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.ServiceNetworking.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.ServiceNetworking.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyword list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.ServiceNetworking.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Connection.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by AddDnsRecordSet API","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest","doc":"Request to add a record set to a private managed DNS zone in the shared producer host project.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is the project number, as in '12345' {network} is the network name.\n*   `dnsRecordSet` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.t`, *default:* `nil`) - Required. The DNS record set to add.\n*   `zone` (*type:* `String.t`, *default:* `nil`) - Required. The name of the private DNS zone in the shared producer host project to which the record set will be added.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsRecordSetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by AddDnsZone API","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest","doc":"Request to add a private managed DNS zone in the shared producer host project and a matching DNS peering zone in the consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is the project number, as in '12345' {network} is the network name.\n*   `dnsSuffix` (*type:* `String.t`, *default:* `nil`) - Required. The DNS name suffix for the zones e.g. `example.com.`. Cloud DNS requires that a DNS suffix ends with a trailing dot.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The name for both the private zone in the shared producer host project and the peering zone in the consumer project. Must be unique within both projects. The name must be 1-63 characters long, must begin with a letter, end with a letter or digit, and only contain lowercase letters, digits or dashes.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse","doc":"Represents managed DNS zones created in the shared producer host and consumer projects.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse","doc":"*   `consumerPeeringZone` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsZone.t`, *default:* `nil`) - The DNS peering zone created in the consumer project.\n*   `producerPrivateZone` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsZone.t`, *default:* `nil`) - The private DNS zone created in the shared producer host project.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddDnsZoneResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by AddRoles API","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest","doc":"Request for AddRoles to allow Service Producers to add roles in the shared VPC host project for them to use.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is a project number, as in '12345' {network} is a network name.\n*   `policyBinding` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.t)`, *default:* `nil`) - Required. List of policy bindings to add to shared VPC host project.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse","doc":"Represents IAM roles added to the shared VPC host project.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse","doc":"*   `policyBinding` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.t)`, *default:* `nil`) - Required. List of policy bindings that were added to the shared VPC host project.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddRolesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest","doc":"Request to create a subnetwork in a previously peered service network.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest","doc":"*   `allowSubnetCidrRoutesOverlap` (*type:* `boolean()`, *default:* `nil`) - Optional. Defines the allowSubnetCidrRoutesOverlap field of the subnet, e.g. Available in alpha and beta according to [Compute API documentation](https://cloud.google.com/compute/docs/reference/rest/beta/subnetworks/insert)\n*   `checkServiceNetworkingUsePermission` (*type:* `boolean()`, *default:* `nil`) - Optional. The IAM permission check determines whether the consumer project has 'servicenetworking.services.use' permission or not.\n*   `computeIdempotencyWindow` (*type:* `String.t`, *default:* `nil`) - Optional. Specifies a custom time bucket for Arcus subnetwork request idempotency. If two equivalent concurrent requests are made, Arcus will know to ignore the request if it has already been completed or is in progress. Only requests with matching compute_idempotency_window have guaranteed idempotency. Changing this time window between requests results in undefined behavior. Zero (or empty) value with custom_compute_idempotency_window=true specifies no idempotency (i.e. no request ID is provided to Arcus). Maximum value of 14 days (enforced by Arcus limit). For more information on how to use, see: go/revisit-sn-idempotency-window\n*   `consumer` (*type:* `String.t`, *default:* `nil`) - Required. A resource that represents the service consumer, such as `projects/123456`. The project number can be different from the value in the consumer network parameter. For example, the network might be part of a Shared VPC network. In those cases, Service Networking validates that this resource belongs to that Shared VPC.\n*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The name of the service consumer's VPC network. The network must have an existing private connection that was provisioned through the connections.create method. The name must be in the following format: `projects/{project}/global/networks/{network}`, where {project} is a project number, such as `12345`. {network} is the name of a VPC network in the project.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. Description of the subnet.\n*   `internalRange` (*type:* `String.t`, *default:* `nil`) - Optional. The url of an Internal Range. Eg: `projects//locations/global/internalRanges/`. If specified, it means that the subnetwork cidr will be created using the combination of requested_address/ip_prefix_length. Note that the subnet cidr has to be within the cidr range of this Internal Range.\n*   `ipPrefixLength` (*type:* `integer()`, *default:* `nil`) - Required. The prefix length of the subnet's IP address range. Use CIDR range notation, such as `29` to provision a subnet with an `x.x.x.x/29` CIDR range. The IP address range is drawn from a pool of available ranges in the service consumer's allocated range. GCE disallows subnets with prefix_length > 29\n*   `outsideAllocationPublicIpRange` (*type:* `String.t`, *default:* `nil`) - Optional. Enable outside allocation using public IP addresses. Any public IP range may be specified. If this field is provided, we will not use customer reserved ranges for this primary IP range.\n*   `privateIpv6GoogleAccess` (*type:* `String.t`, *default:* `nil`) - Optional. The private IPv6 google access type for the VMs in this subnet. For information about the access types that can be set using this field, see [subnetwork](https://cloud.google.com/compute/docs/reference/rest/v1/subnetworks) in the Compute API documentation.\n*   `purpose` (*type:* `String.t`, *default:* `nil`) - Optional. Defines the purpose field of the subnet, e.g. 'PRIVATE_SERVICE_CONNECT'. For information about the purposes that can be set using this field, see [subnetwork](https://cloud.google.com/compute/docs/reference/rest/v1/subnetworks) in the Compute API documentation.\n*   `region` (*type:* `String.t`, *default:* `nil`) - Required. The name of a [region](/compute/docs/regions-zones) for the subnet, such `europe-west1`.\n*   `requestedAddress` (*type:* `String.t`, *default:* `nil`) - Optional. The starting address of a range. The address must be a valid IPv4 address in the x.x.x.x format. This value combined with the IP prefix range is the CIDR range for the subnet. The range must be within the allocated range that is assigned to the private connection. If the CIDR range isn't available, the call fails.\n*   `requestedRanges` (*type:* `list(String.t)`, *default:* `nil`) - Optional. The name of one or more allocated IP address ranges associated with this private service access connection. If no range names are provided all ranges associated with this connection will be considered. If a CIDR range with the specified IP prefix length is not available within these ranges, the call fails.\n*   `role` (*type:* `String.t`, *default:* `nil`) - Optional. Defines the role field of the subnet, e.g. 'ACTIVE'. For information about the roles that can be set using this field, see [subnetwork](https://cloud.google.com/compute/docs/reference/rest/v1/subnetworks) in the Compute API documentation.\n*   `secondaryIpRangeSpecs` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec.t)`, *default:* `nil`) - Optional. A list of secondary IP ranges to be created within the new subnetwork.\n*   `skipRequestedAddressValidation` (*type:* `boolean()`, *default:* `nil`) - Optional. Skips validating if the requested_address is in use by SN VPC’s peering group. Compute Engine will still perform this check and fail the request if the requested_address is in use. Note that Compute Engine does not check for the existence of dynamic routes when performing this check. Caller of this API should make sure that there are no dynamic routes overlapping with the requested_address/prefix_length IP address range otherwise the created subnet could cause misrouting.\n*   `subnetwork` (*type:* `String.t`, *default:* `nil`) - Required. A name for the new subnet. For information about the naming requirements, see [subnetwork](/compute/docs/reference/rest/v1/subnetworks) in the Compute API documentation.\n*   `subnetworkUsers` (*type:* `list(String.t)`, *default:* `nil`) - A list of members that are granted the `roles/servicenetworking.subnetworkAdmin` role on the subnet.\n*   `useCustomComputeIdempotencyWindow` (*type:* `boolean()`, *default:* `nil`) - Optional. Specifies if Service Networking should use a custom time bucket for Arcus idempotency. If false, Service Networking uses a 300 second (5 minute) Arcus idempotency window. If true, Service Networking uses a custom idempotency window provided by the user in field compute_idempotency_window. For more information on how to use, see: go/revisit-sn-idempotency-window","ref":"GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AddSubnetworkRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Api","doc":"Api is a light-weight descriptor for an API Interface. Interfaces are also described as \"protocol buffer services\" in some contexts, such as by the \"service\" keyword in a .proto file, but they are different from API Services, which represent a concrete implementation of an interface as opposed to simply a description of methods and bindings. They are also sometimes simply referred to as \"APIs\" in other contexts, such as the name of this message itself. See https://cloud.google.com/apis/design/glossary for detailed terminology.","ref":"GoogleApi.ServiceNetworking.V1.Model.Api.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Api","doc":"*   `methods` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Method.t)`, *default:* `nil`) - The methods of this interface, in unspecified order.\n*   `mixins` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Mixin.t)`, *default:* `nil`) - Included interfaces. See Mixin.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The fully qualified name of this interface, including package name followed by the interface's simple name.\n*   `options` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Option.t)`, *default:* `nil`) - Any metadata attached to the interface.\n*   `sourceContext` (*type:* `GoogleApi.ServiceNetworking.V1.Model.SourceContext.t`, *default:* `nil`) - Source context for the protocol buffer service represented by this message.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax of the service.\n*   `version` (*type:* `String.t`, *default:* `nil`) - A version string for this interface. If specified, must have the form `major-version.minor-version`, as in `1.10`. If the minor version is omitted, it defaults to zero. If the entire version field is empty, the major version is derived from the package name, as outlined below. If the field is not empty, the version in the package name will be verified to be consistent with what is provided here. The versioning schema uses [semantic versioning](http://semver.org) where the major version number indicates a breaking change and the minor version an additive, non-breaking change. Both version numbers are signals to users what to expect from different versions, and should be carefully chosen based on the product plan. The major version is also reflected in the package name of the interface, which must end in `v`, as in `google.feature.v1`. For major versions 0 and 1, the suffix can be omitted. Zero major versions must only be used for experimental, non-GA interfaces.","ref":"GoogleApi.ServiceNetworking.V1.Model.Api.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Api.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Api.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Api.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Api.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AuthProvider","doc":"Configuration for an authentication provider, including support for [JSON Web Token (JWT)](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32).","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthProvider.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AuthProvider","doc":"*   `audiences` (*type:* `String.t`, *default:* `nil`) - The list of JWT [audiences](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32#section-4.1.3). that are allowed to access. A JWT containing any of these audiences will be accepted. When this setting is absent, JWTs with audiences: - \"https://[service.name]/[google.protobuf.Api.name]\" - \"https://[service.name]/\" will be accepted. For example, if no audiences are in the setting, LibraryService API will accept JWTs with the following audiences: - https://library-example.googleapis.com/google.example.library.v1.LibraryService - https://library-example.googleapis.com/ Example: audiences: bookstore_android.apps.googleusercontent.com, bookstore_web.apps.googleusercontent.com\n*   `authorizationUrl` (*type:* `String.t`, *default:* `nil`) - Redirect URL if JWT token is required but not present or is expired. Implement authorizationUrl of securityDefinitions in OpenAPI spec.\n*   `id` (*type:* `String.t`, *default:* `nil`) - The unique identifier of the auth provider. It will be referred to by `AuthRequirement.provider_id`. Example: \"bookstore_auth\".\n*   `issuer` (*type:* `String.t`, *default:* `nil`) - Identifies the principal that issued the JWT. See https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32#section-4.1.1 Usually a URL or an email address. Example: https://securetoken.google.com Example: 1234567-compute@developer.gserviceaccount.com\n*   `jwksUri` (*type:* `String.t`, *default:* `nil`) - URL of the provider's public key set to validate signature of the JWT. See [OpenID Discovery](https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderMetadata). Optional if the key set document: - can be retrieved from [OpenID Discovery](https://openid.net/specs/openid-connect-discovery-1_0.html) of the issuer. - can be inferred from the email domain of the issuer (e.g. a Google service account). Example: https://www.googleapis.com/oauth2/v1/certs\n*   `jwtLocations` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.JwtLocation.t)`, *default:* `nil`) - Defines the locations to extract the JWT. For now it is only used by the Cloud Endpoints to store the OpenAPI extension [x-google-jwt-locations] (https://cloud.google.com/endpoints/docs/openapi/openapi-extensions#x-google-jwt-locations) JWT locations can be one of HTTP headers, URL query parameters or cookies. The rule is that the first match wins. If not specified, default to use following 3 locations: 1) Authorization: Bearer 2) x-goog-iap-jwt-assertion 3) access_token query parameter Default locations can be specified as followings: jwt_locations: - header: Authorization value_prefix: \"Bearer \" - header: x-goog-iap-jwt-assertion - query: access_token","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthProvider.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AuthProvider.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthProvider.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AuthProvider.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthProvider.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AuthRequirement","doc":"User-defined authentication requirements, including support for [JSON Web Token (JWT)](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32).","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthRequirement.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AuthRequirement","doc":"*   `audiences` (*type:* `String.t`, *default:* `nil`) - NOTE: This will be deprecated soon, once AuthProvider.audiences is implemented and accepted in all the runtime components. The list of JWT [audiences](https://tools.ietf.org/html/draft-ietf-oauth-json-web-token-32#section-4.1.3). that are allowed to access. A JWT containing any of these audiences will be accepted. When this setting is absent, only JWTs with audience \"https://Service_name/API_name\" will be accepted. For example, if no audiences are in the setting, LibraryService API will only accept JWTs with the following audience \"https://library-example.googleapis.com/google.example.library.v1.LibraryService\". Example: audiences: bookstore_android.apps.googleusercontent.com, bookstore_web.apps.googleusercontent.com\n*   `providerId` (*type:* `String.t`, *default:* `nil`) - id from authentication provider. Example: provider_id: bookstore_auth","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthRequirement.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AuthRequirement.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthRequirement.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AuthRequirement.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthRequirement.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Authentication","doc":"`Authentication` defines the authentication configuration for API methods provided by an API service. Example: name: calendar.googleapis.com authentication: providers: - id: google_calendar_auth jwks_uri: https://www.googleapis.com/oauth2/v1/certs issuer: https://securetoken.google.com rules: - selector: \"*\" requirements: provider_id: google_calendar_auth - selector: google.calendar.Delegate oauth: canonical_scopes: https://www.googleapis.com/auth/calendar.read","ref":"GoogleApi.ServiceNetworking.V1.Model.Authentication.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Authentication","doc":"*   `providers` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.AuthProvider.t)`, *default:* `nil`) - Defines a set of authentication providers that a service supports.\n*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule.t)`, *default:* `nil`) - A list of authentication rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceNetworking.V1.Model.Authentication.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Authentication.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Authentication.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Authentication.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Authentication.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule","doc":"Authentication rules for the service. By default, if a method has any authentication requirements, every request must include a valid credential matching one of the requirements. It's an error to include more than one kind of credential in a single request. If a method doesn't have any auth requirements, request credentials will be ignored.","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule","doc":"*   `allowWithoutCredential` (*type:* `boolean()`, *default:* `nil`) - If true, the service accepts API keys without any other credential. This flag only applies to HTTP and gRPC requests.\n*   `oauth` (*type:* `GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements.t`, *default:* `nil`) - The requirements for OAuth credentials.\n*   `requirements` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.AuthRequirement.t)`, *default:* `nil`) - Requirements for additional authentication providers.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.AuthenticationRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Backend","doc":"`Backend` defines the backend configuration for a service.","ref":"GoogleApi.ServiceNetworking.V1.Model.Backend.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Backend","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.BackendRule.t)`, *default:* `nil`) - A list of API backend rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceNetworking.V1.Model.Backend.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Backend.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Backend.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Backend.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Backend.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.BackendRule","doc":"A backend rule provides configuration for an individual API element.","ref":"GoogleApi.ServiceNetworking.V1.Model.BackendRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.BackendRule","doc":"*   `address` (*type:* `String.t`, *default:* `nil`) - The address of the API backend. The scheme is used to determine the backend protocol and security. The following schemes are accepted: SCHEME PROTOCOL SECURITY http:// HTTP None https:// HTTP TLS grpc:// gRPC None grpcs:// gRPC TLS It is recommended to explicitly include a scheme. Leaving out the scheme may cause constrasting behaviors across platforms. If the port is unspecified, the default is: - 80 for schemes without TLS - 443 for schemes with TLS For HTTP backends, use protocol to specify the protocol version.\n*   `deadline` (*type:* `float()`, *default:* `nil`) - The number of seconds to wait for a response from a request. The default varies based on the request protocol and deployment environment.\n*   `disableAuth` (*type:* `boolean()`, *default:* `nil`) - When disable_auth is true, a JWT ID token won't be generated and the original \"Authorization\" HTTP header will be preserved. If the header is used to carry the original token and is expected by the backend, this field must be set to true to preserve the header.\n*   `jwtAudience` (*type:* `String.t`, *default:* `nil`) - The JWT audience is used when generating a JWT ID token for the backend. This ID token will be added in the HTTP \"authorization\" header, and sent to the backend.\n*   `minDeadline` (*type:* `float()`, *default:* `nil`) - Deprecated, do not use.\n*   `operationDeadline` (*type:* `float()`, *default:* `nil`) - The number of seconds to wait for the completion of a long running operation. The default is no deadline.\n*   `overridesByRequestProtocol` (*type:* `%{optional(String.t) => GoogleApi.ServiceNetworking.V1.Model.BackendRule.t}`, *default:* `nil`) - The map between request protocol and the backend address.\n*   `pathTranslation` (*type:* `String.t`, *default:* `nil`) - \n*   `protocol` (*type:* `String.t`, *default:* `nil`) - The protocol used for sending a request to the backend. The supported values are \"http/1.1\" and \"h2\". The default value is inferred from the scheme in the address field: SCHEME PROTOCOL http:// http/1.1 https:// http/1.1 grpc:// h2 grpcs:// h2 For secure HTTP backends (https://) that support HTTP/2, set this field to \"h2\" for improved performance. Configuring this field to non-default values is only supported for secure HTTP backends. This field will be ignored for all other backends. See https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids for more details on the supported values.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceNetworking.V1.Model.BackendRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.BackendRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.BackendRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.BackendRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.BackendRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Billing","doc":"Billing related configuration of the service. The following example shows how to configure monitored resources and metrics for billing, `consumer_destinations` is the only supported destination and the monitored resources need at least one label key `cloud.googleapis.com/location` to indicate the location of the billing usage, using different monitored resources between monitoring and billing is recommended so they can be evolved independently: monitored_resources: - type: library.googleapis.com/billing_branch labels: - key: cloud.googleapis.com/location description: | Predefined label to support billing location restriction. - key: city description: | Custom label to define the city where the library branch is located in. - key: name description: Custom label to define the name of the library branch. metrics: - name: library.googleapis.com/book/borrowed_count metric_kind: DELTA value_type: INT64 unit: \"1\" billing: consumer_destinations: - monitored_resource: library.googleapis.com/billing_branch metrics: - library.googleapis.com/book/borrowed_count","ref":"GoogleApi.ServiceNetworking.V1.Model.Billing.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Billing","doc":"*   `consumerDestinations` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.BillingDestination.t)`, *default:* `nil`) - Billing configurations for sending metrics to the consumer project. There can be multiple consumer destinations per service, each one must have a different monitored resource type. A metric can be used in at most one consumer destination.","ref":"GoogleApi.ServiceNetworking.V1.Model.Billing.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Billing.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Billing.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Billing.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Billing.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.BillingDestination","doc":"Configuration of a specific billing destination (Currently only support bill against consumer project).","ref":"GoogleApi.ServiceNetworking.V1.Model.BillingDestination.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.BillingDestination","doc":"*   `metrics` (*type:* `list(String.t)`, *default:* `nil`) - Names of the metrics to report to this billing destination. Each name must be defined in Service.metrics section.\n*   `monitoredResource` (*type:* `String.t`, *default:* `nil`) - The monitored resource type. The type must be defined in Service.monitored_resources section.","ref":"GoogleApi.ServiceNetworking.V1.Model.BillingDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.BillingDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.BillingDestination.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.BillingDestination.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.BillingDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest","doc":"The request message for Operations.CancelOperation.","ref":"GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CancelOperationRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings","doc":"Details about how and where to publish client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings","doc":"*   `cppSettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CppSettings.t`, *default:* `nil`) - Settings for C++ client libraries.\n*   `dotnetSettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DotnetSettings.t`, *default:* `nil`) - Settings for .NET client libraries.\n*   `goSettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.GoSettings.t`, *default:* `nil`) - Settings for Go client libraries.\n*   `javaSettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.JavaSettings.t`, *default:* `nil`) - Settings for legacy Java features, supported in the Service YAML.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Launch stage of this version of the API.\n*   `nodeSettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.NodeSettings.t`, *default:* `nil`) - Settings for Node client libraries.\n*   `phpSettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.PhpSettings.t`, *default:* `nil`) - Settings for PHP client libraries.\n*   `pythonSettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.PythonSettings.t`, *default:* `nil`) - Settings for Python client libraries.\n*   `restNumericEnums` (*type:* `boolean()`, *default:* `nil`) - When using transport=rest, the client request will encode enums as numbers rather than strings.\n*   `rubySettings` (*type:* `GoogleApi.ServiceNetworking.V1.Model.RubySettings.t`, *default:* `nil`) - Settings for Ruby client libraries.\n*   `version` (*type:* `String.t`, *default:* `nil`) - Version of the API to apply these settings to. This is the full protobuf package for the API, ending in the version element. Examples: \"google.cloud.speech.v1\" and \"google.spanner.admin.database.v1\".","ref":"GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig","doc":"Cloud SQL configuration.","ref":"GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig","doc":"*   `service` (*type:* `String.t`, *default:* `nil`) - Peering service used for peering with the Cloud SQL project.\n*   `umbrellaNetwork` (*type:* `String.t`, *default:* `nil`) - The name of the umbrella network in the Cloud SQL umbrella project.\n*   `umbrellaProject` (*type:* `String.t`, *default:* `nil`) - The project number of the Cloud SQL umbrella project.","ref":"GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings","doc":"Required information for every language.","ref":"GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings","doc":"*   `destinations` (*type:* `list(String.t)`, *default:* `nil`) - The destination where API teams want this client library to be published.\n*   `referenceDocsUri` (*type:* `String.t`, *default:* `nil`) - Link to automatically generated reference documentation. Example: https://cloud.google.com/nodejs/docs/reference/asset/latest\n*   `selectiveGapicGeneration` (*type:* `GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration.t`, *default:* `nil`) - Configuration for which RPCs should be generated in the GAPIC client.","ref":"GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Connection","doc":"Represents a private connection resource. A private connection is implemented as a VPC Network Peering connection between a service producer's VPC network and a service consumer's VPC network.","ref":"GoogleApi.ServiceNetworking.V1.Model.Connection.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Connection","doc":"*   `network` (*type:* `String.t`, *default:* `nil`) - The name of service consumer's VPC network that's connected with service producer network, in the following format: `projects/{project}/global/networks/{network}`. `{project}` is a project number, such as in `12345` that includes the VPC service consumer's VPC network. `{network}` is the name of the service consumer's VPC network.\n*   `peering` (*type:* `String.t`, *default:* `nil`) - Output only. The name of the VPC Network Peering connection that was created by the service producer.\n*   `reservedPeeringRanges` (*type:* `list(String.t)`, *default:* `nil`) - The name of one or more allocated IP address ranges for this service producer of type `PEERING`. Note that invoking CreateConnection method with a different range when connection is already established will not modify already provisioned service producer subnetworks. If CreateConnection method is invoked repeatedly to reconnect when peering connection had been disconnected on the consumer side, leaving this field empty will restore previously allocated IP ranges.\n*   `service` (*type:* `String.t`, *default:* `nil`) - Output only. The name of the peering service that's associated with this connection, in the following format: `services/{service name}`.","ref":"GoogleApi.ServiceNetworking.V1.Model.Connection.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Connection.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Connection.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Connection.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig","doc":"Configuration information for a private service access connection.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig","doc":"*   `cloudsqlConfigs` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.CloudSQLConfig.t)`, *default:* `nil`) - Represents one or multiple Cloud SQL configurations.\n*   `consumerExportCustomRoutes` (*type:* `boolean()`, *default:* `nil`) - Export custom routes flag value for peering from consumer to producer.\n*   `consumerExportSubnetRoutesWithPublicIp` (*type:* `boolean()`, *default:* `nil`) - Export subnet routes with public ip flag value for peering from consumer to producer.\n*   `consumerImportCustomRoutes` (*type:* `boolean()`, *default:* `nil`) - Import custom routes flag value for peering from consumer to producer.\n*   `consumerImportSubnetRoutesWithPublicIp` (*type:* `boolean()`, *default:* `nil`) - Import subnet routes with public ip flag value for peering from consumer to producer.\n*   `producerExportCustomRoutes` (*type:* `boolean()`, *default:* `nil`) - Export custom routes flag value for peering from producer to consumer.\n*   `producerExportSubnetRoutesWithPublicIp` (*type:* `boolean()`, *default:* `nil`) - Export subnet routes with public ip flag value for peering from producer to consumer.\n*   `producerImportCustomRoutes` (*type:* `boolean()`, *default:* `nil`) - Import custom routes flag value for peering from producer to consumer.\n*   `producerImportSubnetRoutesWithPublicIp` (*type:* `boolean()`, *default:* `nil`) - Import subnet routes with public ip flag value for peering from producer to consumer.\n*   `producerNetwork` (*type:* `String.t`, *default:* `nil`) - Output only. The VPC host network that is used to host managed service instances. In the format, projects/{project}/global/networks/{network} where {project} is the project number e.g. '12345' and {network} is the network name.\n*   `reservedRanges` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange.t)`, *default:* `nil`) - Output only. The reserved ranges associated with this private service access connection.\n*   `usedIpRanges` (*type:* `list(String.t)`, *default:* `nil`) - Output only. The IP ranges already in use by consumer or producer\n*   `vpcScReferenceArchitectureEnabled` (*type:* `boolean()`, *default:* `nil`) - Output only. Indicates whether the VPC Service Controls reference architecture is configured for the producer VPC host network.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by UpdateConsumerConfig API.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerConfigMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerProject","doc":"Represents a consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerProject.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ConsumerProject","doc":"*   `projectNum` (*type:* `String.t`, *default:* `nil`) - Required. Project number of the consumer that is launching the service instance. It can own the network that is peered with Google or, be a service project in an XPN where the host project has the network.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerProject.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerProject.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerProject.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ConsumerProject.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ConsumerProject.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Context","doc":"`Context` defines which contexts an API requests. Example: context: rules: - selector: \"*\" requested: - google.rpc.context.ProjectContext - google.rpc.context.OriginContext The above specifies that all methods in the API request `google.rpc.context.ProjectContext` and `google.rpc.context.OriginContext`. Available context types are defined in package `google.rpc.context`. This also provides mechanism to allowlist any protobuf message extension that can be sent in grpc metadata using “x-goog-ext--bin” and “x-goog-ext--jspb” format. For example, list any service specific protobuf types that can appear in grpc metadata as follows in your yaml file: Example: context: rules: - selector: \"google.example.library.v1.LibraryService.CreateBook\" allowed_request_extensions: - google.foo.v1.NewExtension allowed_response_extensions: - google.foo.v1.NewExtension You can also specify extension ID instead of fully qualified extension name here.","ref":"GoogleApi.ServiceNetworking.V1.Model.Context.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Context","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.ContextRule.t)`, *default:* `nil`) - A list of RPC context rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceNetworking.V1.Model.Context.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Context.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Context.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Context.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Context.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ContextRule","doc":"A context rule provides information about the context for an individual API element.","ref":"GoogleApi.ServiceNetworking.V1.Model.ContextRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ContextRule","doc":"*   `allowedRequestExtensions` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names or extension IDs of extensions allowed in grpc side channel from client to backend.\n*   `allowedResponseExtensions` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names or extension IDs of extensions allowed in grpc side channel from backend to client.\n*   `provided` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names of provided contexts. It is used to support propagating HTTP headers and ETags from the response extension.\n*   `requested` (*type:* `list(String.t)`, *default:* `nil`) - A list of full type names of requested contexts, only the requested context will be made available to the backend.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceNetworking.V1.Model.ContextRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ContextRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ContextRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ContextRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ContextRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Control","doc":"Selects and configures the service controller used by the service. Example: control: environment: servicecontrol.googleapis.com","ref":"GoogleApi.ServiceNetworking.V1.Model.Control.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Control","doc":"*   `environment` (*type:* `String.t`, *default:* `nil`) - The service controller environment to use. If empty, no control plane feature (like quota and billing) will be enabled. The recommended value for most services is servicecontrol.googleapis.com\n*   `methodPolicies` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.MethodPolicy.t)`, *default:* `nil`) - Defines policies applying to the API methods of the service.","ref":"GoogleApi.ServiceNetworking.V1.Model.Control.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Control.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Control.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Control.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Control.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.CppSettings","doc":"Settings for C++ client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.CppSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.CppSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceNetworking.V1.Model.CppSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.CppSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.CppSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.CppSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CppSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.CustomError","doc":"Customize service error responses. For example, list any service specific protobuf types that can appear in error detail lists of error responses. Example: custom_error: types: - google.foo.v1.CustomError - google.foo.v1.AnotherError","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomError.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.CustomError","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule.t)`, *default:* `nil`) - The list of custom error rules that apply to individual API messages. **NOTE:** All service configuration rules follow \"last one wins\" order.\n*   `types` (*type:* `list(String.t)`, *default:* `nil`) - The list of custom error detail types, e.g. 'google.foo.v1.CustomError'.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomError.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.CustomError.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomError.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.CustomError.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomError.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule","doc":"A custom error rule.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule","doc":"*   `isErrorType` (*type:* `boolean()`, *default:* `nil`) - Mark this message as possible payload in error response. Otherwise, objects of this type will be filtered when they appear in error payload.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects messages to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomErrorRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern","doc":"A custom pattern is used for defining custom HTTP verb.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern","doc":"*   `kind` (*type:* `String.t`, *default:* `nil`) - The name of this custom HTTP verb.\n*   `path` (*type:* `String.t`, *default:* `nil`) - The path matched by this custom verb.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by Delete Connection API","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest","doc":"Request to delete a private service access connection. The call will fail if there are any managed service instances using this connection.","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is a project number, as in '12345' {network} is a network name.","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DeleteConnectionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by DeletePeeredDnsDomain API.","ref":"GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DeletePeeredDnsDomainMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest","doc":"Request to disable VPC service controls.","ref":"GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is a project number, as in '12345' {network} is network name.","ref":"GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DisableVpcServiceControlsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet","doc":"Represents a DNS record set resource.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet","doc":"*   `data` (*type:* `list(String.t)`, *default:* `nil`) - Required. As defined in RFC 1035 (section 5) and RFC 1034 (section 3.6.1) for examples see https://cloud.google.com/dns/records/json-record.\n*   `domain` (*type:* `String.t`, *default:* `nil`) - Required. The DNS or domain name of the record set, e.g. `test.example.com`. Cloud DNS requires that a DNS suffix ends with a trailing dot.\n*   `ttl` (*type:* `String.t`, *default:* `nil`) - Required. The period of time for which this RecordSet can be cached by resolvers.\n*   `type` (*type:* `String.t`, *default:* `nil`) - Required. The identifier of a supported record type.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DnsZone","doc":"Represents a DNS zone resource.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZone.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DnsZone","doc":"*   `dnsSuffix` (*type:* `String.t`, *default:* `nil`) - The DNS name suffix of this zone e.g. `example.com.`. Cloud DNS requires that a DNS suffix ends with a trailing dot.\n*   `name` (*type:* `String.t`, *default:* `nil`) - User assigned name for this resource. Must be unique within the project. The name must be 1-63 characters long, must begin with a letter, end with a letter or digit, and only contain lowercase letters, digits or dashes.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZone.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DnsZone.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZone.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DnsZone.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZone.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DnsZonePair","doc":"* Represents a pair of private and peering DNS zone resources. *","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZonePair.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DnsZonePair","doc":"*   `consumerPeeringZone` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsZone.t`, *default:* `nil`) - The DNS peering zone in the consumer project.\n*   `producerPrivateZone` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsZone.t`, *default:* `nil`) - The private DNS zone in the shared producer host project.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZonePair.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DnsZonePair.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZonePair.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DnsZonePair.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DnsZonePair.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Documentation","doc":"`Documentation` provides the information for describing a service. Example: documentation: summary: > The Google Calendar API gives access to most calendar features. pages: - name: Overview content: (== include google/foo/overview.md ==) - name: Tutorial content: (== include google/foo/tutorial.md ==) subpages: - name: Java content: (== include google/foo/tutorial_java.md ==) rules: - selector: google.calendar.Calendar.Get description: > ... - selector: google.calendar.Calendar.Put description: > ... Documentation is provided in markdown syntax. In addition to standard markdown features, definition lists, tables and fenced code blocks are supported. Section headers can be provided and are interpreted relative to the section nesting of the context where a documentation fragment is embedded. Documentation from the IDL is merged with documentation defined via the config at normalization time, where documentation provided by config rules overrides IDL provided. A number of constructs specific to the API platform are supported in documentation text. In order to reference a proto element, the following notation can be used: [fully.qualified.proto.name][] To override the display text used for the link, this can be used: [display text][fully.qualified.proto.name] Text can be excluded from doc using the following notation: (-- internal comment --) A few directives are available in documentation. Note that directives must appear on a single line to be properly identified. The `include` directive includes a markdown file from an external source: (== include path/to/file ==) The `resource_for` directive marks a message to be the resource of a collection in REST view. If it is not specified, tools attempt to infer the resource from the operations in a collection: (== resource_for v1.shelves.books ==) The directive `suppress_warning` does not directly affect documentation and is documented together with service config validation.","ref":"GoogleApi.ServiceNetworking.V1.Model.Documentation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Documentation","doc":"*   `documentationRootUrl` (*type:* `String.t`, *default:* `nil`) - The URL to the root of documentation.\n*   `overview` (*type:* `String.t`, *default:* `nil`) - Declares a single overview page. For example: documentation: summary: ... overview: (== include overview.md ==) This is a shortcut for the following declaration (using pages style): documentation: summary: ... pages: - name: Overview content: (== include overview.md ==) Note: you cannot specify both `overview` field and `pages` field.\n*   `pages` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Page.t)`, *default:* `nil`) - The top level pages for the documentation set.\n*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.DocumentationRule.t)`, *default:* `nil`) - A list of documentation rules that apply to individual API elements. **NOTE:** All service configuration rules follow \"last one wins\" order.\n*   `sectionOverrides` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Page.t)`, *default:* `nil`) - Specifies section and content to override boilerplate content provided by go/api-docgen. Currently overrides following sections: 1. rest.service.client_libraries\n*   `serviceRootUrl` (*type:* `String.t`, *default:* `nil`) - Specifies the service root url if the default one (the service name from the yaml file) is not suitable. This can be seen in any fully specified service urls as well as sections that show a base that other urls are relative to.\n*   `summary` (*type:* `String.t`, *default:* `nil`) - A short description of what the service does. The summary must be plain text. It becomes the overview of the service displayed in Google Cloud Console. NOTE: This field is equivalent to the standard field `description`.","ref":"GoogleApi.ServiceNetworking.V1.Model.Documentation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Documentation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Documentation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Documentation.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Documentation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DocumentationRule","doc":"A documentation rule provides information about individual API elements.","ref":"GoogleApi.ServiceNetworking.V1.Model.DocumentationRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DocumentationRule","doc":"*   `deprecationDescription` (*type:* `String.t`, *default:* `nil`) - Deprecation description of the selected element(s). It can be provided if an element is marked as `deprecated`.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Description of the selected proto element (e.g. a message, a method, a 'service' definition, or a field). Defaults to leading & trailing comments taken from the proto source definition of the proto element.\n*   `disableReplacementWords` (*type:* `String.t`, *default:* `nil`) - String of comma or space separated case-sensitive words for which method/field name replacement will be disabled by go/api-docgen.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - The selector is a comma-separated list of patterns for any element such as a method, a field, an enum value. Each pattern is a qualified name of the element which may end in \"*\", indicating a wildcard. Wildcards are only allowed at the end and for a whole component of the qualified name, i.e. \"foo.*\" is ok, but not \"foo.b*\" or \"foo.*.bar\". A wildcard will match one or more components. To specify a default for all applicable elements, the whole pattern \"*\" is used.","ref":"GoogleApi.ServiceNetworking.V1.Model.DocumentationRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DocumentationRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DocumentationRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DocumentationRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DocumentationRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.DotnetSettings","doc":"Settings for Dotnet client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.DotnetSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.DotnetSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.\n*   `forcedNamespaceAliases` (*type:* `list(String.t)`, *default:* `nil`) - Namespaces which must be aliased in snippets due to a known (but non-generator-predictable) naming collision\n*   `handwrittenSignatures` (*type:* `list(String.t)`, *default:* `nil`) - Method signatures (in the form \"service.method(signature)\") which are provided separately, so shouldn't be generated. Snippets *calling* these methods are still generated, however.\n*   `ignoredResources` (*type:* `list(String.t)`, *default:* `nil`) - List of full resource types to ignore during generation. This is typically used for API-specific Location resources, which should be handled by the generator as if they were actually the common Location resources. Example entry: \"documentai.googleapis.com/Location\"\n*   `renamedResources` (*type:* `map()`, *default:* `nil`) - Map from full resource types to the effective short name for the resource. This is used when otherwise resource named from different services would cause naming collisions. Example entry: \"datalabeling.googleapis.com/Dataset\": \"DataLabelingDataset\"\n*   `renamedServices` (*type:* `map()`, *default:* `nil`) - Map from original service names to renamed versions. This is used when the default generated types would cause a naming conflict. (Neither name is fully-qualified.) Example: Subscriber to SubscriberServiceApi.","ref":"GoogleApi.ServiceNetworking.V1.Model.DotnetSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.DotnetSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.DotnetSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.DotnetSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.DotnetSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Empty","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); }","ref":"GoogleApi.ServiceNetworking.V1.Model.Empty.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Empty","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Empty.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Empty.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Empty.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Empty.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Empty.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest","doc":"Request to enable VPC service controls.","ref":"GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is a project number, as in '12345' {network} is network name.","ref":"GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.EnableVpcServiceControlsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Endpoint","doc":"`Endpoint` describes a network address of a service that serves a set of APIs. It is commonly known as a service endpoint. A service may expose any number of service endpoints, and all service endpoints share the same service definition, such as quota limits and monitoring metrics. Example: type: google.api.Service name: library-example.googleapis.com endpoints: # Declares network address `https://library-example.googleapis.com` # for service `library-example.googleapis.com`. The `https` scheme # is implicit for all service endpoints. Other schemes may be # supported in the future. - name: library-example.googleapis.com allow_cors: false - name: content-staging-library-example.googleapis.com # Allows HTTP OPTIONS calls to be passed to the API frontend, for it # to decide whether the subsequent cross-origin request is allowed # to proceed. allow_cors: true","ref":"GoogleApi.ServiceNetworking.V1.Model.Endpoint.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Endpoint","doc":"*   `aliases` (*type:* `list(String.t)`, *default:* `nil`) - Aliases for this endpoint, these will be served by the same UrlMap as the parent endpoint, and will be provisioned in the GCP stack for the Regional Endpoints.\n*   `allowCors` (*type:* `boolean()`, *default:* `nil`) - Allowing [CORS](https://en.wikipedia.org/wiki/Cross-origin_resource_sharing), aka cross-domain traffic, would allow the backends served from this endpoint to receive and respond to HTTP OPTIONS requests. The response will be used by the browser to determine whether the subsequent cross-origin request is allowed to proceed.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The canonical name of this endpoint.\n*   `target` (*type:* `String.t`, *default:* `nil`) - The specification of an Internet routable address of API frontend that will handle requests to this [API Endpoint](https://cloud.google.com/apis/design/glossary). It should be either a valid IPv4 address or a fully-qualified domain name. For example, \"8.8.8.8\" or \"myservice.appspot.com\".","ref":"GoogleApi.ServiceNetworking.V1.Model.Endpoint.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Endpoint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Endpoint.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Endpoint.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Endpoint.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Enum","doc":"Enum type definition.","ref":"GoogleApi.ServiceNetworking.V1.Model.Enum.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Enum","doc":"*   `edition` (*type:* `String.t`, *default:* `nil`) - The source edition string, only valid when syntax is SYNTAX_EDITIONS.\n*   `enumvalue` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.EnumValue.t)`, *default:* `nil`) - Enum value definitions.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Enum type name.\n*   `options` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Option.t)`, *default:* `nil`) - Protocol buffer options.\n*   `sourceContext` (*type:* `GoogleApi.ServiceNetworking.V1.Model.SourceContext.t`, *default:* `nil`) - The source context.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax.","ref":"GoogleApi.ServiceNetworking.V1.Model.Enum.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Enum.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Enum.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Enum.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Enum.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.EnumValue","doc":"Enum value definition.","ref":"GoogleApi.ServiceNetworking.V1.Model.EnumValue.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.EnumValue","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - Enum value name.\n*   `number` (*type:* `integer()`, *default:* `nil`) - Enum value number.\n*   `options` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Option.t)`, *default:* `nil`) - Protocol buffer options.","ref":"GoogleApi.ServiceNetworking.V1.Model.EnumValue.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.EnumValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.EnumValue.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.EnumValue.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.EnumValue.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures","doc":"Experimental features to be included during client library generation. These fields will be deprecated once the feature graduates and is enabled by default.","ref":"GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures","doc":"*   `protobufPythonicTypesEnabled` (*type:* `boolean()`, *default:* `nil`) - Enables generation of protobuf code using new types that are more Pythonic which are included in `protobuf>=5.29.x`. This feature will be enabled by default 1 month after launching the feature in preview packages.\n*   `restAsyncIoEnabled` (*type:* `boolean()`, *default:* `nil`) - Enables generation of asynchronous REST clients if `rest` transport is enabled. By default, asynchronous REST clients will not be generated. This feature will be enabled by default 1 month after launching the feature in preview packages.","ref":"GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Field","doc":"A single field of a message type.","ref":"GoogleApi.ServiceNetworking.V1.Model.Field.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Field","doc":"*   `cardinality` (*type:* `String.t`, *default:* `nil`) - The field cardinality.\n*   `defaultValue` (*type:* `String.t`, *default:* `nil`) - The string value of the default value of this field. Proto2 syntax only.\n*   `jsonName` (*type:* `String.t`, *default:* `nil`) - The field JSON name.\n*   `kind` (*type:* `String.t`, *default:* `nil`) - The field type.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The field name.\n*   `number` (*type:* `integer()`, *default:* `nil`) - The field number.\n*   `oneofIndex` (*type:* `integer()`, *default:* `nil`) - The index of the field type in `Type.oneofs`, for message or enumeration types. The first type has index 1; zero means the type is not in the list.\n*   `options` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Option.t)`, *default:* `nil`) - The protocol buffer options.\n*   `packed` (*type:* `boolean()`, *default:* `nil`) - Whether to use alternative packed wire representation.\n*   `typeUrl` (*type:* `String.t`, *default:* `nil`) - The field type URL, without the scheme, for message or enumeration types. Example: `\"type.googleapis.com/google.protobuf.Timestamp\"`.","ref":"GoogleApi.ServiceNetworking.V1.Model.Field.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Field.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Field.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Field.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Field.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.FieldPolicy","doc":"Google API Policy Annotation This message defines a simple API policy annotation that can be used to annotate API request and response message fields with applicable policies. One field may have multiple applicable policies that must all be satisfied before a request can be processed. This policy annotation is used to generate the overall policy that will be used for automatic runtime policy enforcement and documentation generation.","ref":"GoogleApi.ServiceNetworking.V1.Model.FieldPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.FieldPolicy","doc":"*   `resourcePermission` (*type:* `String.t`, *default:* `nil`) - Specifies the required permission(s) for the resource referred to by the field. It requires the field contains a valid resource reference, and the request must pass the permission checks to proceed. For example, \"resourcemanager.projects.get\".\n*   `resourceType` (*type:* `String.t`, *default:* `nil`) - Specifies the resource type for the resource referred to by the field.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects one or more request or response message fields to apply this `FieldPolicy`. When a `FieldPolicy` is used in proto annotation, the selector must be left as empty. The service config generator will automatically fill the correct value. When a `FieldPolicy` is used in service config, the selector must be a comma-separated string with valid request or response field paths, such as \"foo.bar\" or \"foo.bar,foo.baz\".","ref":"GoogleApi.ServiceNetworking.V1.Model.FieldPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.FieldPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.FieldPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.FieldPolicy.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.FieldPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse","doc":"Represents managed DNS zones created in the shared Producer host and consumer projects.","ref":"GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse","doc":"*   `consumerPeeringZone` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsZone.t`, *default:* `nil`) - The DNS peering zone created in the consumer project.\n*   `producerPrivateZone` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsZone.t`, *default:* `nil`) - The private DNS zone created in the shared producer host project.","ref":"GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.GetDnsZoneResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.GoSettings","doc":"Settings for Go client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.GoSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.GoSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.GoSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.GoSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange","doc":"Allocated IP address ranges for this private service access connection.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange","doc":"*   `address` (*type:* `String.t`, *default:* `nil`) - The starting address of the reserved range. The address must be a valid IPv4 address in the x.x.x.x format. This value combined with the IP prefix length is the CIDR range for the reserved range.\n*   `ipPrefixLength` (*type:* `integer()`, *default:* `nil`) - The prefix length of the reserved range.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the reserved range.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1ConsumerConfigReservedRange.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection","doc":"Represents a private connection resource. A private connection is implemented as a VPC Network Peering connection between a service producer's VPC network and a service consumer's VPC network.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection","doc":"*   `network` (*type:* `String.t`, *default:* `nil`) - The name of service consumer's VPC network that's connected with service producer network, in the following format: `projects/{project}/global/networks/{network}`. `{project}` is a project number, such as in `12345` that includes the VPC service consumer's VPC network. `{network}` is the name of the service consumer's VPC network.\n*   `peering` (*type:* `String.t`, *default:* `nil`) - Output only. The name of the VPC Network Peering connection that was created by the service producer.\n*   `reservedPeeringRanges` (*type:* `list(String.t)`, *default:* `nil`) - The name of one or more allocated IP address ranges for this service producer of type `PEERING`. Note that invoking this method with a different range when connection is already established will not modify already provisioned service producer subnetworks.\n*   `service` (*type:* `String.t`, *default:* `nil`) - Output only. The name of the peering service that's associated with this connection, in the following format: `services/{service name}`.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaConnection.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork","doc":"Represents a subnet that was created or discovered by a private access management service.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork","doc":"*   `ipCidrRange` (*type:* `String.t`, *default:* `nil`) - Subnetwork CIDR range in `10.x.x.x/y` format.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Subnetwork name. See https://cloud.google.com/compute/docs/vpc/\n*   `network` (*type:* `String.t`, *default:* `nil`) - In the Shared VPC host project, the VPC network that's peered with the consumer network. For example: `projects/1234321/global/networks/host-network`\n*   `outsideAllocation` (*type:* `boolean()`, *default:* `nil`) - This is a discovered subnet that is not within the current consumer allocated ranges.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.GoogleCloudServicenetworkingV1betaSubnetwork.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Http","doc":"Defines the HTTP configuration for an API service. It contains a list of HttpRule, each specifying the mapping of an RPC method to one or more HTTP REST API methods.","ref":"GoogleApi.ServiceNetworking.V1.Model.Http.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Http","doc":"*   `fullyDecodeReservedExpansion` (*type:* `boolean()`, *default:* `nil`) - When set to true, URL path parameters will be fully URI-decoded except in cases of single segment matches in reserved expansion, where \"%2F\" will be left encoded. The default behavior is to not decode RFC 6570 reserved characters in multi segment matches.\n*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.HttpRule.t)`, *default:* `nil`) - A list of HTTP configuration rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceNetworking.V1.Model.Http.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Http.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Http.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Http.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Http.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.HttpRule","doc":"gRPC Transcoding gRPC Transcoding is a feature for mapping between a gRPC method and one or more HTTP REST endpoints. It allows developers to build a single API service that supports both gRPC APIs and REST APIs. Many systems, including [Google APIs](https://github.com/googleapis/googleapis), [Cloud Endpoints](https://cloud.google.com/endpoints), [gRPC Gateway](https://github.com/grpc-ecosystem/grpc-gateway), and [Envoy](https://github.com/envoyproxy/envoy) proxy support this feature and use it for large scale production services. `HttpRule` defines the schema of the gRPC/REST mapping. The mapping specifies how different portions of the gRPC request message are mapped to the URL path, URL query parameters, and HTTP request body. It also controls how the gRPC response message is mapped to the HTTP response body. `HttpRule` is typically specified as an `google.api.http` annotation on the gRPC method. Each mapping specifies a URL path template and an HTTP method. The path template may refer to one or more fields in the gRPC request message, as long as each field is a non-repeated field with a primitive (non-message) type. The path template controls how fields of the request message are mapped to the URL path. Example: service Messaging { rpc GetMessage(GetMessageRequest) returns (Message) { option (google.api.http) = { get: \"/v1/{name=messages/*}\" }; } } message GetMessageRequest { string name = 1; // Mapped to URL path. } message Message { string text = 1; // The resource content. } This enables an HTTP REST to gRPC mapping as below: - HTTP: `GET /v1/messages/123456` - gRPC: `GetMessage(name: \"messages/123456\")` Any fields in the request message which are not bound by the path template automatically become HTTP query parameters if there is no HTTP request body. For example: service Messaging { rpc GetMessage(GetMessageRequest) returns (Message) { option (google.api.http) = { get:\"/v1/messages/{message_id}\" }; } } message GetMessageRequest { message SubMessage { string subfield = 1; } string message_id = 1; // Mapped to URL path. int64 revision = 2; // Mapped to URL query parameter `revision`. SubMessage sub = 3; // Mapped to URL query parameter `sub.subfield`. } This enables a HTTP JSON to RPC mapping as below: - HTTP: `GET /v1/messages/123456?revision=2&sub.subfield=foo` - gRPC: `GetMessage(message_id: \"123456\" revision: 2 sub: SubMessage(subfield: \"foo\"))` Note that fields which are mapped to URL query parameters must have a primitive type or a repeated primitive type or a non-repeated message type. In the case of a repeated type, the parameter can be repeated in the URL as `...?param=A&param=B`. In the case of a message type, each field of the message is mapped to a separate parameter, such as `...?foo.a=A&foo.b=B&foo.c=C`. For HTTP methods that allow a request body, the `body` field specifies the mapping. Consider a REST update method on the message resource collection: service Messaging { rpc UpdateMessage(UpdateMessageRequest) returns (Message) { option (google.api.http) = { patch: \"/v1/messages/{message_id}\" body: \"message\" }; } } message UpdateMessageRequest { string message_id = 1; // mapped to the URL Message message = 2; // mapped to the body } The following HTTP JSON to RPC mapping is enabled, where the representation of the JSON in the request body is determined by protos JSON encoding: - HTTP: `PATCH /v1/messages/123456 { \"text\": \"Hi!\" }` - gRPC: `UpdateMessage(message_id: \"123456\" message { text: \"Hi!\" })` The special name `*` can be used in the body mapping to define that every field not bound by the path template should be mapped to the request body. This enables the following alternative definition of the update method: service Messaging { rpc UpdateMessage(Message) returns (Message) { option (google.api.http) = { patch: \"/v1/messages/{message_id}\" body: \"*\" }; } } message Message { string message_id = 1; string text = 2; } The following HTTP JSON to RPC mapping is enabled: - HTTP: `PATCH /v1/messages/123456 { \"text\": \"Hi!\" }` - gRPC: `UpdateMessage(message_id: \"123456\" text: \"Hi!\")` Note that when using `*` in the body mapping, it is not possible to have HTTP parameters, as all fields not bound by the path end in the body. This makes this option more rarely used in practice when defining REST APIs. The common usage of `*` is in custom methods which don't use the URL at all for transferring data. It is possible to define multiple HTTP methods for one RPC by using the `additional_bindings` option. Example: service Messaging { rpc GetMessage(GetMessageRequest) returns (Message) { option (google.api.http) = { get: \"/v1/messages/{message_id}\" additional_bindings { get: \"/v1/users/{user_id}/messages/{message_id}\" } }; } } message GetMessageRequest { string message_id = 1; string user_id = 2; } This enables the following two alternative HTTP JSON to RPC mappings: - HTTP: `GET /v1/messages/123456` - gRPC: `GetMessage(message_id: \"123456\")` - HTTP: `GET /v1/users/me/messages/123456` - gRPC: `GetMessage(user_id: \"me\" message_id: \"123456\")` Rules for HTTP mapping 1. Leaf request fields (recursive expansion nested messages in the request message) are classified into three categories: - Fields referred by the path template. They are passed via the URL path. - Fields referred by the HttpRule.body. They are passed via the HTTP request body. - All other fields are passed via the URL query parameters, and the parameter name is the field path in the request message. A repeated field can be represented as multiple query parameters under the same name. 2. If HttpRule.body is \"*\", there is no URL query parameter, all fields are passed via URL path and HTTP request body. 3. If HttpRule.body is omitted, there is no HTTP request body, all fields are passed via URL path and URL query parameters. Path template syntax Template = \"/\" Segments [ Verb ] ; Segments = Segment { \"/\" Segment } ; Segment = \"*\" | \"**\" | LITERAL | Variable ; Variable = \"{\" FieldPath [ \"=\" Segments ] \"}\" ; FieldPath = IDENT { \".\" IDENT } ; Verb = \":\" LITERAL ; The syntax `*` matches a single URL path segment. The syntax `**` matches zero or more URL path segments, which must be the last part of the URL path except the `Verb`. The syntax `Variable` matches part of the URL path as specified by its template. A variable template must not contain other variables. If a variable matches a single path segment, its template may be omitted, e.g. `{var}` is equivalent to `{var=*}`. The syntax `LITERAL` matches literal text in the URL path. If the `LITERAL` contains any reserved character, such characters should be percent-encoded before the matching. If a variable contains exactly one path segment, such as `\"{var}\"` or `\"{var=*}\"`, when such a variable is expanded into a URL path on the client side, all characters except `[-_.~0-9a-zA-Z]` are percent-encoded. The server side does the reverse decoding. Such variables show up in the [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) as `{var}`. If a variable contains multiple path segments, such as `\"{var=foo/*}\"` or `\"{var=**}\"`, when such a variable is expanded into a URL path on the client side, all characters except `[-_.~/0-9a-zA-Z]` are percent-encoded. The server side does the reverse decoding, except \"%2F\" and \"%2f\" are left unchanged. Such variables show up in the [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) as `{+var}`. Using gRPC API Service Configuration gRPC API Service Configuration (service config) is a configuration language for configuring a gRPC service to become a user-facing product. The service config is simply the YAML representation of the `google.api.Service` proto message. As an alternative to annotating your proto file, you can configure gRPC transcoding in your service config YAML files. You do this by specifying a `HttpRule` that maps the gRPC method to a REST endpoint, achieving the same effect as the proto annotation. This can be particularly useful if you have a proto that is reused in multiple services. Note that any transcoding specified in the service config will override any matching transcoding configuration in the proto. The following example selects a gRPC method and applies an `HttpRule` to it: http: rules: - selector: example.v1.Messaging.GetMessage get: /v1/messages/{message_id}/{sub.subfield} Special notes When gRPC Transcoding is used to map a gRPC to JSON REST endpoints, the proto to JSON conversion must follow the [proto3 specification](https://developers.google.com/protocol-buffers/docs/proto3#json). While the single segment variable follows the semantics of [RFC 6570](https://tools.ietf.org/html/rfc6570) Section 3.2.2 Simple String Expansion, the multi segment variable **does not** follow RFC 6570 Section 3.2.3 Reserved Expansion. The reason is that the Reserved Expansion does not expand special characters like `?` and `#`, which would lead to invalid URLs. As the result, gRPC Transcoding uses a custom encoding for multi segment variables. The path variables **must not** refer to any repeated or mapped field, because client libraries are not capable of handling such variable expansion. The path variables **must not** capture the leading \"/\" character. The reason is that the most common use case \"{var}\" does not capture the leading \"/\" character. For consistency, all path variables must share the same behavior. Repeated message fields must not be mapped to URL query parameters, because no client library can support such complicated mapping. If an API needs to use a JSON array for request or response body, it can map the request or response body to a repeated field. However, some gRPC Transcoding implementations may not support this feature.","ref":"GoogleApi.ServiceNetworking.V1.Model.HttpRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.HttpRule","doc":"*   `additionalBindings` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.HttpRule.t)`, *default:* `nil`) - Additional HTTP bindings for the selector. Nested bindings must not contain an `additional_bindings` field themselves (that is, the nesting may only be one level deep).\n*   `body` (*type:* `String.t`, *default:* `nil`) - The name of the request field whose value is mapped to the HTTP request body, or `*` for mapping all request fields not captured by the path pattern to the HTTP body, or omitted for not having any HTTP request body. NOTE: the referred field must be present at the top-level of the request message type.\n*   `custom` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CustomHttpPattern.t`, *default:* `nil`) - The custom pattern is used for specifying an HTTP method that is not included in the `pattern` field, such as HEAD, or \"*\" to leave the HTTP method unspecified for this rule. The wild-card rule is useful for services that provide content to Web (HTML) clients.\n*   `delete` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP DELETE. Used for deleting a resource.\n*   `get` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP GET. Used for listing and getting information about resources.\n*   `patch` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP PATCH. Used for updating a resource.\n*   `post` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP POST. Used for creating a resource or performing an action.\n*   `put` (*type:* `String.t`, *default:* `nil`) - Maps to HTTP PUT. Used for replacing a resource.\n*   `responseBody` (*type:* `String.t`, *default:* `nil`) - Optional. The name of the response field whose value is mapped to the HTTP response body. When omitted, the entire response message will be used as the HTTP response body. NOTE: The referred field must be present at the top-level of the response message type.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects a method to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceNetworking.V1.Model.HttpRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.HttpRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.HttpRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.HttpRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.HttpRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.JavaSettings","doc":"Settings for Java client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.JavaSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.JavaSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.\n*   `libraryPackage` (*type:* `String.t`, *default:* `nil`) - The package name to use in Java. Clobbers the java_package option set in the protobuf. This should be used **only** by APIs who have already set the language_settings.java.package_name\" field in gapic.yaml. API teams should use the protobuf java_package option where possible. Example of a YAML configuration:: publishing: java_settings: library_package: com.google.cloud.pubsub.v1\n*   `serviceClassNames` (*type:* `map()`, *default:* `nil`) - Configure the Java class name to use instead of the service's for its corresponding generated GAPIC client. Keys are fully-qualified service names as they appear in the protobuf (including the full the language_settings.java.interface_names\" field in gapic.yaml. API teams should otherwise use the service name as it appears in the protobuf. Example of a YAML configuration:: publishing: java_settings: service_class_names: - google.pubsub.v1.Publisher: TopicAdmin - google.pubsub.v1.Subscriber: SubscriptionAdmin","ref":"GoogleApi.ServiceNetworking.V1.Model.JavaSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.JavaSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.JavaSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.JavaSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.JavaSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.JwtLocation","doc":"Specifies a location to extract JWT from an API request.","ref":"GoogleApi.ServiceNetworking.V1.Model.JwtLocation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.JwtLocation","doc":"*   `cookie` (*type:* `String.t`, *default:* `nil`) - Specifies cookie name to extract JWT token.\n*   `header` (*type:* `String.t`, *default:* `nil`) - Specifies HTTP header name to extract JWT token.\n*   `query` (*type:* `String.t`, *default:* `nil`) - Specifies URL query parameter name to extract JWT token.\n*   `valuePrefix` (*type:* `String.t`, *default:* `nil`) - The value prefix. The value format is \"value_prefix{token}\" Only applies to \"in\" header type. Must be empty for \"in\" query type. If not empty, the header value has to match (case sensitive) this prefix. If not matched, JWT will not be extracted. If matched, JWT will be extracted after the prefix is removed. For example, for \"Authorization: Bearer {JWT}\", value_prefix=\"Bearer \" with a space at the end.","ref":"GoogleApi.ServiceNetworking.V1.Model.JwtLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.JwtLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.JwtLocation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.JwtLocation.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.JwtLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor","doc":"A description of a label.","ref":"GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - A human-readable description for the label.\n*   `key` (*type:* `String.t`, *default:* `nil`) - The label key.\n*   `valueType` (*type:* `String.t`, *default:* `nil`) - The type of data that can be assigned to the label.","ref":"GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse","doc":"ListConnectionsResponse is the response to list peering states for the given service and consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse","doc":"*   `connections` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Connection.t)`, *default:* `nil`) - The list of Connections.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ListConnectionsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse","doc":"Represents all DNS RecordSets associated with the producer network","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse","doc":"*   `dnsRecordSets` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.t)`, *default:* `nil`) - DNS record Set Resource","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsRecordSetsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse","doc":"Represents all DNS zones in the shared producer host project and the matching peering zones in the consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse","doc":"*   `dnsZonePairs` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.DnsZonePair.t)`, *default:* `nil`) - All pairs of private DNS zones in the shared producer host project and the matching peering zones in the consumer project..","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ListDnsZonesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse","doc":"The response message for Operations.ListOperations.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The standard List next-page token.\n*   `operations` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Operation.t)`, *default:* `nil`) - A list of operations that matches the specified filter in the request.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ListOperationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse","doc":"Response to list peered DNS domains for a given connection.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse","doc":"*   `peeredDnsDomains` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.t)`, *default:* `nil`) - The list of peered DNS domains.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ListPeeredDnsDomainsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.LogDescriptor","doc":"A description of a log type. Example in YAML format: - name: library.googleapis.com/activity_history description: The history of borrowing and returning library items. display_name: Activity labels: - key: /customer_id description: Identifier of a library customer","ref":"GoogleApi.ServiceNetworking.V1.Model.LogDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.LogDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - A human-readable description of this log. This information appears in the documentation and can contain details.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - The human-readable name for this log. This information appears on the user interface and should be concise.\n*   `labels` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.t)`, *default:* `nil`) - The set of labels that are available to describe a specific log entry. Runtime requests that contain labels not specified here are considered invalid.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the log. It must be less than 512 characters long and can include the following characters: upper- and lower-case alphanumeric characters [A-Za-z0-9], and punctuation characters including slash, underscore, hyphen, period [/_-.].","ref":"GoogleApi.ServiceNetworking.V1.Model.LogDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.LogDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.LogDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.LogDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.LogDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Logging","doc":"Logging configuration of the service. The following example shows how to configure logs to be sent to the producer and consumer projects. In the example, the `activity_history` log is sent to both the producer and consumer projects, whereas the `purchase_history` log is only sent to the producer project. monitored_resources: - type: library.googleapis.com/branch labels: - key: /city description: The city where the library branch is located in. - key: /name description: The name of the branch. logs: - name: activity_history labels: - key: /customer_id - name: purchase_history logging: producer_destinations: - monitored_resource: library.googleapis.com/branch logs: - activity_history - purchase_history consumer_destinations: - monitored_resource: library.googleapis.com/branch logs: - activity_history","ref":"GoogleApi.ServiceNetworking.V1.Model.Logging.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Logging","doc":"*   `consumerDestinations` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.t)`, *default:* `nil`) - Logging configurations for sending logs to the consumer project. There can be multiple consumer destinations, each one must have a different monitored resource type. A log can be used in at most one consumer destination.\n*   `producerDestinations` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.t)`, *default:* `nil`) - Logging configurations for sending logs to the producer project. There can be multiple producer destinations, each one must have a different monitored resource type. A log can be used in at most one producer destination.","ref":"GoogleApi.ServiceNetworking.V1.Model.Logging.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Logging.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Logging.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Logging.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Logging.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.LoggingDestination","doc":"Configuration of a specific logging destination (the producer project or the consumer project).","ref":"GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.LoggingDestination","doc":"*   `logs` (*type:* `list(String.t)`, *default:* `nil`) - Names of the logs to be sent to this destination. Each name must be defined in the Service.logs section. If the log name is not a domain scoped name, it will be automatically prefixed with the service name followed by \"/\".\n*   `monitoredResource` (*type:* `String.t`, *default:* `nil`) - The monitored resource type. The type must be defined in the Service.monitored_resources section.","ref":"GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.LoggingDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.LongRunning","doc":"Describes settings to use when generating API methods that use the long-running operation pattern. All default values below are from those used in the client library generators (e.g. [Java](https://github.com/googleapis/gapic-generator-java/blob/04c2faa191a9b5a10b92392fe8482279c4404803/src/main/java/com/google/api/generator/gapic/composer/common/RetrySettingsComposer.java)).","ref":"GoogleApi.ServiceNetworking.V1.Model.LongRunning.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.LongRunning","doc":"*   `initialPollDelay` (*type:* `String.t`, *default:* `nil`) - Initial delay after which the first poll request will be made. Default value: 5 seconds.\n*   `maxPollDelay` (*type:* `String.t`, *default:* `nil`) - Maximum time between two subsequent poll requests. Default value: 45 seconds.\n*   `pollDelayMultiplier` (*type:* `number()`, *default:* `nil`) - Multiplier to gradually increase delay between subsequent polls until it reaches max_poll_delay. Default value: 1.5.\n*   `totalPollTimeout` (*type:* `String.t`, *default:* `nil`) - Total polling timeout. Default value: 5 minutes.","ref":"GoogleApi.ServiceNetworking.V1.Model.LongRunning.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.LongRunning.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.LongRunning.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.LongRunning.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.LongRunning.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Method","doc":"Method represents a method of an API interface.","ref":"GoogleApi.ServiceNetworking.V1.Model.Method.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Method","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The simple name of this method.\n*   `options` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Option.t)`, *default:* `nil`) - Any metadata attached to the method.\n*   `requestStreaming` (*type:* `boolean()`, *default:* `nil`) - If true, the request is streamed.\n*   `requestTypeUrl` (*type:* `String.t`, *default:* `nil`) - A URL of the input message type.\n*   `responseStreaming` (*type:* `boolean()`, *default:* `nil`) - If true, the response is streamed.\n*   `responseTypeUrl` (*type:* `String.t`, *default:* `nil`) - The URL of the output message type.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax of this method.","ref":"GoogleApi.ServiceNetworking.V1.Model.Method.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Method.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Method.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Method.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Method.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.MethodPolicy","doc":"Defines policies applying to an RPC method.","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodPolicy.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.MethodPolicy","doc":"*   `requestPolicies` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.FieldPolicy.t)`, *default:* `nil`) - Policies that are applicable to the request message.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects a method to which these policies should be enforced, for example, \"google.pubsub.v1.Subscriber.CreateSubscription\". Refer to selector for syntax details. NOTE: This field must not be set in the proto annotation. It will be automatically filled by the service config compiler .","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodPolicy.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.MethodPolicy.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodPolicy.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.MethodPolicy.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodPolicy.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.MethodSettings","doc":"Describes the generator configuration for a method.","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.MethodSettings","doc":"*   `autoPopulatedFields` (*type:* `list(String.t)`, *default:* `nil`) - List of top-level fields of the request message, that should be automatically populated by the client libraries based on their (google.api.field_info).format. Currently supported format: UUID4. Example of a YAML configuration: publishing: method_settings: - selector: google.example.v1.ExampleService.CreateExample auto_populated_fields: - request_id\n*   `longRunning` (*type:* `GoogleApi.ServiceNetworking.V1.Model.LongRunning.t`, *default:* `nil`) - Describes settings to use for long-running operations when generating API methods for RPCs. Complements RPCs that use the annotations in google/longrunning/operations.proto. Example of a YAML configuration:: publishing: method_settings: - selector: google.cloud.speech.v2.Speech.BatchRecognize long_running: initial_poll_delay: 60s # 1 minute poll_delay_multiplier: 1.5 max_poll_delay: 360s # 6 minutes total_poll_timeout: 54000s # 90 minutes\n*   `selector` (*type:* `String.t`, *default:* `nil`) - The fully qualified name of the method, for which the options below apply. This is used to find the method to apply the options. Example: publishing: method_settings: - selector: google.storage.control.v2.StorageControl.CreateFolder # method settings for CreateFolder...","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.MethodSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.MethodSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.MethodSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor","doc":"Defines a metric type and its schema. Once a metric descriptor is created, deleting or altering it stops data collection and makes the metric type's existing data unusable.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - A detailed description of the metric, which can be used in documentation.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - A concise name for the metric, which can be displayed in user interfaces. Use sentence case without an ending period, for example \"Request count\". This field is optional but it is recommended to be set for any metrics associated with user-visible concepts, such as Quota.\n*   `labels` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.t)`, *default:* `nil`) - The set of labels that can be used to describe a specific instance of this metric type. For example, the `appengine.googleapis.com/http/server/response_latencies` metric type has a label for the HTTP response code, `response_code`, so you can look at latencies for successful responses or just for responses that failed.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Optional. The launch stage of the metric definition.\n*   `metadata` (*type:* `GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata.t`, *default:* `nil`) - Optional. Metadata which can be used to guide usage of the metric.\n*   `metricKind` (*type:* `String.t`, *default:* `nil`) - Whether the metric records instantaneous values, changes to a value, etc. Some combinations of `metric_kind` and `value_type` might not be supported.\n*   `monitoredResourceTypes` (*type:* `list(String.t)`, *default:* `nil`) - Read-only. If present, then a time series, which is identified partially by a metric type and a MonitoredResourceDescriptor, that is associated with this metric type can only be associated with one of the monitored resource types listed here.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The resource name of the metric descriptor.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The metric type, including its DNS name prefix. The type is not URL-encoded. All user-defined metric types have the DNS name `custom.googleapis.com` or `external.googleapis.com`. Metric types should use a natural hierarchical grouping. For example: \"custom.googleapis.com/invoice/paid/amount\" \"external.googleapis.com/prometheus/up\" \"appengine.googleapis.com/http/server/response_latencies\"\n*   `unit` (*type:* `String.t`, *default:* `nil`) - The units in which the metric value is reported. It is only applicable if the `value_type` is `INT64`, `DOUBLE`, or `DISTRIBUTION`. The `unit` defines the representation of the stored metric values. Different systems might scale the values to be more easily displayed (so a value of `0.02kBy` _might_ be displayed as `20By`, and a value of `3523kBy` _might_ be displayed as `3.5MBy`). However, if the `unit` is `kBy`, then the value of the metric is always in thousands of bytes, no matter how it might be displayed. If you want a custom metric to record the exact number of CPU-seconds used by a job, you can create an `INT64 CUMULATIVE` metric whose `unit` is `s{CPU}` (or equivalently `1s{CPU}` or just `s`). If the job uses 12,005 CPU-seconds, then the value is written as `12005`. Alternatively, if you want a custom metric to record data in a more granular way, you can create a `DOUBLE CUMULATIVE` metric whose `unit` is `ks{CPU}`, and then write the value `12.005` (which is `12005/1000`), or use `Kis{CPU}` and write `11.723` (which is `12005/1024`). The supported units are a subset of [The Unified Code for Units of Measure](https://unitsofmeasure.org/ucum.html) standard: **Basic units (UNIT)** * `bit` bit * `By` byte * `s` second * `min` minute * `h` hour * `d` day * `1` dimensionless **Prefixes (PREFIX)** * `k` kilo (10^3) * `M` mega (10^6) * `G` giga (10^9) * `T` tera (10^12) * `P` peta (10^15) * `E` exa (10^18) * `Z` zetta (10^21) * `Y` yotta (10^24) * `m` milli (10^-3) * `u` micro (10^-6) * `n` nano (10^-9) * `p` pico (10^-12) * `f` femto (10^-15) * `a` atto (10^-18) * `z` zepto (10^-21) * `y` yocto (10^-24) * `Ki` kibi (2^10) * `Mi` mebi (2^20) * `Gi` gibi (2^30) * `Ti` tebi (2^40) * `Pi` pebi (2^50) **Grammar** The grammar also includes these connectors: * `/` division or ratio (as an infix operator). For examples, `kBy/{email}` or `MiBy/10ms` (although you should almost never have `/s` in a metric `unit`; rates should always be computed at query time from the underlying cumulative or delta value). * `.` multiplication or composition (as an infix operator). For examples, `GBy.d` or `k{watt}.h`. The grammar for a unit is as follows: Expression = Component { \".\" Component } { \"/\" Component } ; Component = ( [ PREFIX ] UNIT | \"%\" ) [ Annotation ] | Annotation | \"1\" ; Annotation = \"{\" NAME \"}\" ; Notes: * `Annotation` is just a comment if it follows a `UNIT`. If the annotation is used alone, then the unit is equivalent to `1`. For examples, `{request}/s == 1/s`, `By{transmitted}/s == By/s`. * `NAME` is a sequence of non-blank printable ASCII characters not containing `{` or `}`. * `1` represents a unitary [dimensionless unit](https://en.wikipedia.org/wiki/Dimensionless_quantity) of 1, such as in `1/s`. It is typically used when none of the basic units are appropriate. For example, \"new users per day\" can be represented as `1/d` or `{new-users}/d` (and a metric value `5` would mean \"5 new users). Alternatively, \"thousands of page views per day\" would be represented as `1000/d` or `k1/d` or `k{page_views}/d` (and a metric value of `5.3` would mean \"5300 page views per day\"). * `%` represents dimensionless value of 1/100, and annotates values giving a percentage (so the metric values are typically in the range of 0..100, and a metric value `3` means \"3 percent\"). * `10^2.%` indicates a metric contains a ratio, typically in the range 0..1, that will be multiplied by 100 and displayed as a percentage (so a metric value `0.03` means \"3 percent\").\n*   `valueType` (*type:* `String.t`, *default:* `nil`) - Whether the measurement is an integer, a floating-point number, etc. Some combinations of `metric_kind` and `value_type` might not be supported.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata","doc":"Additional annotations that can be used to guide the usage of a metric.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata","doc":"*   `ingestDelay` (*type:* `String.t`, *default:* `nil`) - The delay of data points caused by ingestion. Data points older than this age are guaranteed to be ingested and available to be read, excluding data loss due to errors.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Deprecated. Must use the MetricDescriptor.launch_stage instead.\n*   `samplePeriod` (*type:* `String.t`, *default:* `nil`) - The sampling period of metric data points. For metrics which are written periodically, consecutive data points are stored at this time interval, excluding data loss due to errors. Metrics with a higher granularity have a smaller sampling period.\n*   `timeSeriesResourceHierarchyLevel` (*type:* `list(String.t)`, *default:* `nil`) - The scope of the timeseries data of the metric.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricDescriptorMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.MetricRule","doc":"Bind API methods to metrics. Binding a method to a metric causes that metric's configured quota behaviors to apply to the method call.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.MetricRule","doc":"*   `metricCosts` (*type:* `map()`, *default:* `nil`) - Metrics to update when the selected methods are called, and the associated cost applied to each metric. The key of the map is the metric name, and the values are the amount increased for the metric against which the quota limits are defined. The value must not be negative.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Refer to selector for syntax details.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.MetricRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.MetricRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.MetricRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Mixin","doc":"Declares an API Interface to be included in this interface. The including interface must redeclare all the methods from the included interface, but documentation and options are inherited as follows: - If after comment and whitespace stripping, the documentation string of the redeclared method is empty, it will be inherited from the original method. - Each annotation belonging to the service config (http, visibility) which is not set in the redeclared method will be inherited. - If an http annotation is inherited, the path pattern will be modified as follows. Any version prefix will be replaced by the version of the including interface plus the root path if specified. Example of a simple mixin: package google.acl.v1; service AccessControl { // Get the underlying ACL object. rpc GetAcl(GetAclRequest) returns (Acl) { option (google.api.http).get = \"/v1/{resource=**}:getAcl\"; } } package google.storage.v2; service Storage { // rpc GetAcl(GetAclRequest) returns (Acl); // Get a data record. rpc GetData(GetDataRequest) returns (Data) { option (google.api.http).get = \"/v2/{resource=**}\"; } } Example of a mixin configuration: apis: - name: google.storage.v2.Storage mixins: - name: google.acl.v1.AccessControl The mixin construct implies that all methods in `AccessControl` are also declared with same name and request/response types in `Storage`. A documentation generator or annotation processor will see the effective `Storage.GetAcl` method after inheriting documentation and annotations as follows: service Storage { // Get the underlying ACL object. rpc GetAcl(GetAclRequest) returns (Acl) { option (google.api.http).get = \"/v2/{resource=**}:getAcl\"; } ... } Note how the version in the path pattern changed from `v1` to `v2`. If the `root` field in the mixin is specified, it should be a relative path under which inherited HTTP paths are placed. Example: apis: - name: google.storage.v2.Storage mixins: - name: google.acl.v1.AccessControl root: acls This implies the following inherited HTTP annotation: service Storage { // Get the underlying ACL object. rpc GetAcl(GetAclRequest) returns (Acl) { option (google.api.http).get = \"/v2/acls/{resource=**}:getAcl\"; } ... }","ref":"GoogleApi.ServiceNetworking.V1.Model.Mixin.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Mixin","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The fully qualified name of the interface which is included.\n*   `root` (*type:* `String.t`, *default:* `nil`) - If non-empty specifies a path under which inherited HTTP paths are rooted.","ref":"GoogleApi.ServiceNetworking.V1.Model.Mixin.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Mixin.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Mixin.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Mixin.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Mixin.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor","doc":"An object that describes the schema of a MonitoredResource object using a type name and a set of labels. For example, the monitored resource descriptor for Google Compute Engine VM instances has a type of `\"gce_instance\"` and specifies the use of the labels `\"instance_id\"` and `\"zone\"` to identify particular VM instances. Different APIs can support different monitored resource types. APIs generally provide a `list` method that returns the monitored resource descriptors used by the API.","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. A detailed description of the monitored resource type that might be used in documentation.\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - Optional. A concise name for the monitored resource type that might be displayed in user interfaces. It should be a Title Cased Noun Phrase, without any article or other determiners. For example, `\"Google Cloud SQL Database\"`.\n*   `labels` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.LabelDescriptor.t)`, *default:* `nil`) - Required. A set of labels used to describe instances of this monitored resource type. For example, an individual Google Cloud SQL database is identified by values for the labels `\"database_id\"` and `\"zone\"`.\n*   `launchStage` (*type:* `String.t`, *default:* `nil`) - Optional. The launch stage of the monitored resource definition.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Optional. The resource name of the monitored resource descriptor: `\"projects/{project_id}/monitoredResourceDescriptors/{type}\"` where {type} is the value of the `type` field in this object and {project_id} is a project ID that provides API-specific context for accessing the type. APIs that do not use project information can use the resource name format `\"monitoredResourceDescriptors/{type}\"`.\n*   `type` (*type:* `String.t`, *default:* `nil`) - Required. The monitored resource type. For example, the type `\"cloudsql_database\"` represents databases in Google Cloud SQL. For a list of types, see [Monitored resource types](https://cloud.google.com/monitoring/api/resources) and [Logging resource types](https://cloud.google.com/logging/docs/api/v2/resource-list).","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Monitoring","doc":"Monitoring configuration of the service. The example below shows how to configure monitored resources and metrics for monitoring. In the example, a monitored resource and two metrics are defined. The `library.googleapis.com/book/returned_count` metric is sent to both producer and consumer projects, whereas the `library.googleapis.com/book/num_overdue` metric is only sent to the consumer project. monitored_resources: - type: library.googleapis.com/Branch display_name: \"Library Branch\" description: \"A branch of a library.\" launch_stage: GA labels: - key: resource_container description: \"The Cloud container (ie. project id) for the Branch.\" - key: location description: \"The location of the library branch.\" - key: branch_id description: \"The id of the branch.\" metrics: - name: library.googleapis.com/book/returned_count display_name: \"Books Returned\" description: \"The count of books that have been returned.\" launch_stage: GA metric_kind: DELTA value_type: INT64 unit: \"1\" labels: - key: customer_id description: \"The id of the customer.\" - name: library.googleapis.com/book/num_overdue display_name: \"Books Overdue\" description: \"The current number of overdue books.\" launch_stage: GA metric_kind: GAUGE value_type: INT64 unit: \"1\" labels: - key: customer_id description: \"The id of the customer.\" monitoring: producer_destinations: - monitored_resource: library.googleapis.com/Branch metrics: - library.googleapis.com/book/returned_count consumer_destinations: - monitored_resource: library.googleapis.com/Branch metrics: - library.googleapis.com/book/returned_count - library.googleapis.com/book/num_overdue","ref":"GoogleApi.ServiceNetworking.V1.Model.Monitoring.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Monitoring","doc":"*   `consumerDestinations` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.t)`, *default:* `nil`) - Monitoring configurations for sending metrics to the consumer project. There can be multiple consumer destinations. A monitored resource type may appear in multiple monitoring destinations if different aggregations are needed for different sets of metrics associated with that monitored resource type. A monitored resource and metric pair may only be used once in the Monitoring configuration.\n*   `producerDestinations` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.t)`, *default:* `nil`) - Monitoring configurations for sending metrics to the producer project. There can be multiple producer destinations. A monitored resource type may appear in multiple monitoring destinations if different aggregations are needed for different sets of metrics associated with that monitored resource type. A monitored resource and metric pair may only be used once in the Monitoring configuration.","ref":"GoogleApi.ServiceNetworking.V1.Model.Monitoring.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Monitoring.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Monitoring.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Monitoring.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Monitoring.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination","doc":"Configuration of a specific monitoring destination (the producer project or the consumer project).","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination","doc":"*   `metrics` (*type:* `list(String.t)`, *default:* `nil`) - Types of the metrics to report to this monitoring destination. Each type must be defined in Service.metrics section.\n*   `monitoredResource` (*type:* `String.t`, *default:* `nil`) - The monitored resource type. The type must be defined in Service.monitored_resources section.","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.MonitoringDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.NodeSettings","doc":"Settings for Node client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.NodeSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.NodeSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceNetworking.V1.Model.NodeSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.NodeSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.NodeSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.NodeSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.NodeSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements","doc":"OAuth scopes are a way to define data and permissions on data. For example, there are scopes defined for \"Read-only access to Google Calendar\" and \"Access to Cloud Platform\". Users can consent to a scope for an application, giving it permission to access that data on their behalf. OAuth scope specifications should be fairly coarse grained; a user will need to see and understand the text description of what your scope means. In most cases: use one or at most two OAuth scopes for an entire family of products. If your product has multiple APIs, you should probably be sharing the OAuth scope across all of those APIs. When you need finer grained OAuth consent screens: talk with your product management about how developers will use them in practice. Please note that even though each of the canonical scopes is enough for a request to be accepted and passed to the backend, a request can still fail due to the backend requiring additional scopes or permissions.","ref":"GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements","doc":"*   `canonicalScopes` (*type:* `String.t`, *default:* `nil`) - The list of publicly documented OAuth scopes that are allowed access. An OAuth token containing any of these scopes will be accepted. Example: canonical_scopes: https://www.googleapis.com/auth/calendar, https://www.googleapis.com/auth/calendar.read","ref":"GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.OAuthRequirements.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Operation","doc":"This resource represents a long-running operation that is the result of a network API call.","ref":"GoogleApi.ServiceNetworking.V1.Model.Operation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Operation","doc":"*   `done` (*type:* `boolean()`, *default:* `nil`) - If the value is `false`, it means the operation is still in progress. If `true`, the operation is completed, and either `error` or `response` is available.\n*   `error` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Status.t`, *default:* `nil`) - The error result of the operation in case of failure or cancellation.\n*   `metadata` (*type:* `map()`, *default:* `nil`) - Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the `name` should be a resource name ending with `operations/{unique_id}`.\n*   `response` (*type:* `map()`, *default:* `nil`) - The normal, successful response of the operation. If the original method returns no data on success, such as `Delete`, the response is `google.protobuf.Empty`. If the original method is standard `Get`/`Create`/`Update`, the response should be the resource. For other methods, the response should have the type `XxxResponse`, where `Xxx` is the original method name. For example, if the original method name is `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`.","ref":"GoogleApi.ServiceNetworking.V1.Model.Operation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Operation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Operation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Operation.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Operation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Option","doc":"A protocol buffer option, which can be attached to a message, field, enumeration, etc.","ref":"GoogleApi.ServiceNetworking.V1.Model.Option.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Option","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The option's name. For protobuf built-in options (options defined in descriptor.proto), this is the short name. For example, `\"map_entry\"`. For custom options, it should be the fully-qualified name. For example, `\"google.api.http\"`.\n*   `value` (*type:* `map()`, *default:* `nil`) - The option's value packed in an Any message. If the value is a primitive, the corresponding wrapper type defined in google/protobuf/wrappers.proto should be used. If the value is an enum, it should be stored as an int32 value using the google.protobuf.Int32Value type.","ref":"GoogleApi.ServiceNetworking.V1.Model.Option.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Option.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Option.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Option.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Option.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Page","doc":"Represents a documentation page. A page can contain subpages to represent nested documentation set structure.","ref":"GoogleApi.ServiceNetworking.V1.Model.Page.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Page","doc":"*   `content` (*type:* `String.t`, *default:* `nil`) - The Markdown content of the page. You can use (== include {path} ==) to include content from a Markdown file. The content can be used to produce the documentation page such as HTML format page.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the page. It will be used as an identity of the page to generate URI of the page, text of the link to this page in navigation, etc. The full page name (start from the root page name to this page concatenated with `.`) can be used as reference to the page in your documentation. For example: pages: - name: Tutorial content: (== include tutorial.md ==) subpages: - name: Java content: (== include tutorial_java.md ==) You can reference `Java` page using Markdown reference link syntax: `Java`.\n*   `subpages` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Page.t)`, *default:* `nil`) - Subpages of this page. The order of subpages specified here will be honored in the generated docset.","ref":"GoogleApi.ServiceNetworking.V1.Model.Page.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Page.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Page.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Page.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Page.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by Partial Delete Connection API","ref":"GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PartialDeleteConnectionMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain","doc":"DNS domain suffix for which requests originating in the producer VPC network are resolved in the associated consumer VPC network.","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain","doc":"*   `dnsSuffix` (*type:* `String.t`, *default:* `nil`) - The DNS domain name suffix e.g. `example.com.`. Cloud DNS requires that a DNS suffix ends with a trailing dot.\n*   `name` (*type:* `String.t`, *default:* `nil`) - User assigned name for this resource. Must be unique within the consumer network. The name must be 1-63 characters long, must begin with a letter, end with a letter or digit, and only contain lowercase letters, digits or dashes.","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomain.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by CreatePeeredDnsDomain API.","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PeeredDnsDomainMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.PhpSettings","doc":"Settings for Php client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.PhpSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.PhpSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceNetworking.V1.Model.PhpSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.PhpSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.PhpSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.PhpSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PhpSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.PolicyBinding","doc":"Grouping of IAM role and IAM member.","ref":"GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.PolicyBinding","doc":"*   `member` (*type:* `String.t`, *default:* `nil`) - Required. Member to bind the role with. See /iam/docs/reference/rest/v1/Policy#Binding for how to format each member. Eg. - user:myuser@mydomain.com - serviceAccount:my-service-account@app.gserviceaccount.com\n*   `role` (*type:* `String.t`, *default:* `nil`) - Required. Role to apply. Only allowlisted roles can be used at the specified granularity. The role must be one of the following: - 'roles/container.hostServiceAgentUser' applied on the shared VPC host project - 'roles/compute.securityAdmin' applied on the shared VPC host project - 'roles/compute.networkAdmin' applied on the shared VPC host project - 'roles/tpu.xpnAgent' applied on the shared VPC host project - 'roles/dns.admin' applied on the shared VPC host project - 'roles/logging.admin' applied on the shared VPC host project - 'roles/monitoring.viewer' applied on the shared VPC host project - 'roles/servicemanagement.quotaViewer' applied on the shared VPC host project","ref":"GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PolicyBinding.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Publishing","doc":"This message configures the settings for publishing [Google Cloud Client libraries](https://cloud.google.com/apis/docs/cloud-client-libraries) generated from the service config.","ref":"GoogleApi.ServiceNetworking.V1.Model.Publishing.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Publishing","doc":"*   `apiShortName` (*type:* `String.t`, *default:* `nil`) - Used as a tracking tag when collecting data about the APIs developer relations artifacts like docs, packages delivered to package managers, etc. Example: \"speech\".\n*   `codeownerGithubTeams` (*type:* `list(String.t)`, *default:* `nil`) - GitHub teams to be added to CODEOWNERS in the directory in GitHub containing source code for the client libraries for this API.\n*   `docTagPrefix` (*type:* `String.t`, *default:* `nil`) - A prefix used in sample code when demarking regions to be included in documentation.\n*   `documentationUri` (*type:* `String.t`, *default:* `nil`) - Link to product home page. Example: https://cloud.google.com/asset-inventory/docs/overview\n*   `githubLabel` (*type:* `String.t`, *default:* `nil`) - GitHub label to apply to issues and pull requests opened for this API.\n*   `librarySettings` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.ClientLibrarySettings.t)`, *default:* `nil`) - Client library settings. If the same version string appears multiple times in this list, then the last one wins. Settings from earlier settings with the same version string are discarded.\n*   `methodSettings` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.MethodSettings.t)`, *default:* `nil`) - A list of API method settings, e.g. the behavior for methods that use the long-running operation pattern.\n*   `newIssueUri` (*type:* `String.t`, *default:* `nil`) - Link to a *public* URI where users can report issues. Example: https://issuetracker.google.com/issues/new?component=190865&template=1161103\n*   `organization` (*type:* `String.t`, *default:* `nil`) - For whom the client library is being published.\n*   `protoReferenceDocumentationUri` (*type:* `String.t`, *default:* `nil`) - Optional link to proto reference documentation. Example: https://cloud.google.com/pubsub/lite/docs/reference/rpc\n*   `restReferenceDocumentationUri` (*type:* `String.t`, *default:* `nil`) - Optional link to REST reference documentation. Example: https://cloud.google.com/pubsub/lite/docs/reference/rest","ref":"GoogleApi.ServiceNetworking.V1.Model.Publishing.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Publishing.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Publishing.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Publishing.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Publishing.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.PythonSettings","doc":"Settings for Python client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.PythonSettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.PythonSettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.\n*   `experimentalFeatures` (*type:* `GoogleApi.ServiceNetworking.V1.Model.ExperimentalFeatures.t`, *default:* `nil`) - Experimental features to be included during client library generation.","ref":"GoogleApi.ServiceNetworking.V1.Model.PythonSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.PythonSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.PythonSettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.PythonSettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.PythonSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Quota","doc":"Quota configuration helps to achieve fairness and budgeting in service usage. The metric based quota configuration works this way: - The service configuration defines a set of metrics. - For API calls, the quota.metric_rules maps methods to metrics with corresponding costs. - The quota.limits defines limits on the metrics, which will be used for quota checks at runtime. An example quota configuration in yaml format: quota: limits: - name: apiWriteQpsPerProject metric: library.googleapis.com/write_calls unit: \"1/min/{project}\" # rate limit for consumer projects values: STANDARD: 10000 (The metric rules bind all methods to the read_calls metric, except for the UpdateBook and DeleteBook methods. These two methods are mapped to the write_calls metric, with the UpdateBook method consuming at twice rate as the DeleteBook method.) metric_rules: - selector: \"*\" metric_costs: library.googleapis.com/read_calls: 1 - selector: google.example.library.v1.LibraryService.UpdateBook metric_costs: library.googleapis.com/write_calls: 2 - selector: google.example.library.v1.LibraryService.DeleteBook metric_costs: library.googleapis.com/write_calls: 1 Corresponding Metric definition: metrics: - name: library.googleapis.com/read_calls display_name: Read requests metric_kind: DELTA value_type: INT64 - name: library.googleapis.com/write_calls display_name: Write requests metric_kind: DELTA value_type: INT64","ref":"GoogleApi.ServiceNetworking.V1.Model.Quota.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Quota","doc":"*   `limits` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.QuotaLimit.t)`, *default:* `nil`) - List of QuotaLimit definitions for the service.\n*   `metricRules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.MetricRule.t)`, *default:* `nil`) - List of MetricRule definitions, each one mapping a selected method to one or more metrics.","ref":"GoogleApi.ServiceNetworking.V1.Model.Quota.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Quota.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Quota.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Quota.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Quota.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.QuotaLimit","doc":"`QuotaLimit` defines a specific limit that applies over a specified duration for a limit type. There can be at most one limit for a duration and limit type combination defined within a `QuotaGroup`.","ref":"GoogleApi.ServiceNetworking.V1.Model.QuotaLimit.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.QuotaLimit","doc":"*   `defaultLimit` (*type:* `String.t`, *default:* `nil`) - Default number of tokens that can be consumed during the specified duration. This is the number of tokens assigned when a client application developer activates the service for his/her project. Specifying a value of 0 will block all requests. This can be used if you are provisioning quota to selected consumers and blocking others. Similarly, a value of -1 will indicate an unlimited quota. No other negative values are allowed. Used by group-based quotas only.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. User-visible, extended description for this quota limit. Should be used only when more context is needed to understand this limit than provided by the limit's display name (see: `display_name`).\n*   `displayName` (*type:* `String.t`, *default:* `nil`) - User-visible display name for this limit. Optional. If not set, the UI will provide a default display name based on the quota configuration. This field can be used to override the default display name generated from the configuration.\n*   `duration` (*type:* `String.t`, *default:* `nil`) - Duration of this limit in textual notation. Must be \"100s\" or \"1d\". Used by group-based quotas only.\n*   `freeTier` (*type:* `String.t`, *default:* `nil`) - Free tier value displayed in the Developers Console for this limit. The free tier is the number of tokens that will be subtracted from the billed amount when billing is enabled. This field can only be set on a limit with duration \"1d\", in a billable group; it is invalid on any other limit. If this field is not set, it defaults to 0, indicating that there is no free tier for this service. Used by group-based quotas only.\n*   `maxLimit` (*type:* `String.t`, *default:* `nil`) - Maximum number of tokens that can be consumed during the specified duration. Client application developers can override the default limit up to this maximum. If specified, this value cannot be set to a value less than the default limit. If not specified, it is set to the default limit. To allow clients to apply overrides with no upper bound, set this to -1, indicating unlimited maximum quota. Used by group-based quotas only.\n*   `metric` (*type:* `String.t`, *default:* `nil`) - The name of the metric this quota limit applies to. The quota limits with the same metric will be checked together during runtime. The metric must be defined within the service config.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Name of the quota limit. The name must be provided, and it must be unique within the service. The name can only include alphanumeric characters as well as '-'. The maximum length of the limit name is 64 characters.\n*   `unit` (*type:* `String.t`, *default:* `nil`) - Specify the unit of the quota limit. It uses the same syntax as MetricDescriptor.unit. The supported unit kinds are determined by the quota backend system. Here are some examples: * \"1/min/{project}\" for quota per minute per project. Note: the order of unit components is insignificant. The \"1\" at the beginning is required to follow the metric unit syntax.\n*   `values` (*type:* `map()`, *default:* `nil`) - Tiered limit values. You must specify this as a key:value pair, with an integer value that is the maximum number of requests allowed for the specified unit. Currently only STANDARD is supported.","ref":"GoogleApi.ServiceNetworking.V1.Model.QuotaLimit.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.QuotaLimit.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.QuotaLimit.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.QuotaLimit.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.QuotaLimit.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Range","doc":"Represents a found unused range.","ref":"GoogleApi.ServiceNetworking.V1.Model.Range.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Range","doc":"*   `ipCidrRange` (*type:* `String.t`, *default:* `nil`) - CIDR range in \"10.x.x.x/y\" format that is within the allocated ranges and currently unused.\n*   `network` (*type:* `String.t`, *default:* `nil`) - In the Shared VPC host project, the VPC network that's peered with the consumer network. For example: `projects/1234321/global/networks/host-network`","ref":"GoogleApi.ServiceNetworking.V1.Model.Range.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Range.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Range.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Range.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Range.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RangeReservation","doc":"Represents a range reservation.","ref":"GoogleApi.ServiceNetworking.V1.Model.RangeReservation.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RangeReservation","doc":"*   `ipPrefixLength` (*type:* `integer()`, *default:* `nil`) - Required. The size of the desired subnet. Use usual CIDR range notation. For example, '29' to find unused x.x.x.x/29 CIDR range. The goal is to determine if one of the allocated ranges has enough free space for a subnet of the requested size. GCE disallows subnets with prefix_length > 29\n*   `requestedRanges` (*type:* `list(String.t)`, *default:* `nil`) - Optional. The name of one or more allocated IP address ranges associated with this private service access connection. If no range names are provided all ranges associated with this connection will be considered. If a CIDR range with the specified IP prefix length is not available within these ranges the validation fails.\n*   `secondaryRangeIpPrefixLengths` (*type:* `list(integer())`, *default:* `nil`) - Optional. The size of the desired secondary ranges for the subnet. Use usual CIDR range notation. For example, '29' to find unused x.x.x.x/29 CIDR range. The goal is to determine that the allocated ranges have enough free space for all the requested secondary ranges. GCE disallows subnets with prefix_length > 29\n*   `subnetworkCandidates` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Subnetwork.t)`, *default:* `nil`) - Optional. List of subnetwork candidates to validate. The required input fields are `name`, `network`, and `region`. Subnetworks from this list which exist will be returned in the response with the `ip_cidr_range`, `secondary_ip_cider_ranges`, and `outside_allocation` fields set.","ref":"GoogleApi.ServiceNetworking.V1.Model.RangeReservation.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RangeReservation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RangeReservation.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RangeReservation.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RangeReservation.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by RemoveDnsRecordSet API","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest","doc":"Request to remove a record set from a private managed DNS zone in the shared producer host project. The name, type, ttl, and data values must all exactly match an existing record set in the specified zone.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is the project number, as in '12345' {network} is the network name.\n*   `dnsRecordSet` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.t`, *default:* `nil`) - Required. The DNS record set to remove.\n*   `zone` (*type:* `String.t`, *default:* `nil`) - Required. The name of the private DNS zone in the shared producer host project from which the record set will be removed.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse","doc":"Blank message response type for RemoveDnsRecordSet API","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsRecordSetResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by RemoveDnsZone API","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest","doc":"Request to remove a private managed DNS zone in the shared producer host project and a matching DNS peering zone in the consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is the project number, as in '12345' {network} is the network name.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Required. The name for both the private zone in the shared producer host project and the peering zone in the consumer project.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse","doc":"Blank message response type for RemoveDnsZone API","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RemoveDnsZoneResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Route","doc":"Represents a route that was created or discovered by a private access management service.","ref":"GoogleApi.ServiceNetworking.V1.Model.Route.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Route","doc":"*   `destRange` (*type:* `String.t`, *default:* `nil`) - Destination CIDR range that this route applies to.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Route name. See https://cloud.google.com/vpc/docs/routes\n*   `network` (*type:* `String.t`, *default:* `nil`) - Fully-qualified URL of the VPC network in the producer host tenant project that this route applies to. For example: `projects/123456/global/networks/host-network`\n*   `nextHopGateway` (*type:* `String.t`, *default:* `nil`) - Fully-qualified URL of the gateway that should handle matching packets that this route applies to. For example: `projects/123456/global/gateways/default-internet-gateway`","ref":"GoogleApi.ServiceNetworking.V1.Model.Route.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Route.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Route.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Route.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Route.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.RubySettings","doc":"Settings for Ruby client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.RubySettings.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.RubySettings","doc":"*   `common` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CommonLanguageSettings.t`, *default:* `nil`) - Some settings.","ref":"GoogleApi.ServiceNetworking.V1.Model.RubySettings.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.RubySettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.RubySettings.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.RubySettings.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.RubySettings.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest","doc":"Request to search for an unused range within allocated ranges.","ref":"GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest","doc":"*   `ipPrefixLength` (*type:* `integer()`, *default:* `nil`) - Required. The prefix length of the IP range. Use usual CIDR range notation. For example, '30' to find unused x.x.x.x/30 CIDR range. Actual range will be determined using allocated range for the consumer peered network and returned in the result.\n*   `network` (*type:* `String.t`, *default:* `nil`) - Network name in the consumer project. This network must have been already peered with a shared VPC network using CreateConnection method. Must be in a form 'projects/{project}/global/networks/{network}'. {project} is a project number, as in '12345' {network} is network name.","ref":"GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SearchRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange","doc":"*   `ipCidrRange` (*type:* `String.t`, *default:* `nil`) - Secondary IP CIDR range in `x.x.x.x/y` format.\n*   `rangeName` (*type:* `String.t`, *default:* `nil`) - Name of the secondary IP range.","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec","doc":"*   `ipPrefixLength` (*type:* `integer()`, *default:* `nil`) - Required. The prefix length of the secondary IP range. Use CIDR range notation, such as `30` to provision a secondary IP range with an `x.x.x.x/30` CIDR range. The IP address range is drawn from a pool of available ranges in the service consumer's allocated range.\n*   `outsideAllocationPublicIpRange` (*type:* `String.t`, *default:* `nil`) - Optional. Enable outside allocation using public IP addresses. Any public IP range may be specified. If this field is provided, we will not use customer reserved ranges for this secondary IP range.\n*   `rangeName` (*type:* `String.t`, *default:* `nil`) - Required. A name for the secondary IP range. The name must be 1-63 characters long, and comply with RFC1035. The name must be unique within the subnetwork.\n*   `requestedAddress` (*type:* `String.t`, *default:* `nil`) - Optional. The starting address of a range. The address must be a valid IPv4 address in the x.x.x.x format. This value combined with the IP prefix range is the CIDR range for the secondary IP range. The range must be within the allocated range that is assigned to the private connection. If the CIDR range isn't available, the call fails.","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRangeSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration","doc":"This message is used to configure the generation of a subset of the RPCs in a service for client libraries.","ref":"GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration","doc":"*   `methods` (*type:* `list(String.t)`, *default:* `nil`) - An allowlist of the fully qualified names of RPCs that should be included on public client surfaces.","ref":"GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SelectiveGapicGeneration.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Service","doc":"`Service` is the root object of Google API service configuration (service config). It describes the basic information about a logical service, such as the service name and the user-facing title, and delegates other aspects to sub-sections. Each sub-section is either a proto message or a repeated proto message that configures a specific aspect, such as auth. For more information, see each proto message definition. Example: type: google.api.Service name: calendar.googleapis.com title: Google Calendar API apis: - name: google.calendar.v3.Calendar visibility: rules: - selector: \"google.calendar.v3.*\" restriction: PREVIEW backend: rules: - selector: \"google.calendar.v3.*\" address: calendar.example.com authentication: providers: - id: google_calendar_auth jwks_uri: https://www.googleapis.com/oauth2/v1/certs issuer: https://securetoken.google.com rules: - selector: \"*\" requirements: provider_id: google_calendar_auth","ref":"GoogleApi.ServiceNetworking.V1.Model.Service.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Service","doc":"*   `apis` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Api.t)`, *default:* `nil`) - A list of API interfaces exported by this service. Only the `name` field of the google.protobuf.Api needs to be provided by the configuration author, as the remaining fields will be derived from the IDL during the normalization process. It is an error to specify an API interface here which cannot be resolved against the associated IDL files.\n*   `authentication` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Authentication.t`, *default:* `nil`) - Auth configuration.\n*   `backend` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Backend.t`, *default:* `nil`) - API backend configuration.\n*   `billing` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Billing.t`, *default:* `nil`) - Billing configuration.\n*   `configVersion` (*type:* `integer()`, *default:* `nil`) - Obsolete. Do not use. This field has no semantic meaning. The service config compiler always sets this field to `3`.\n*   `context` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Context.t`, *default:* `nil`) - Context configuration.\n*   `control` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Control.t`, *default:* `nil`) - Configuration for the service control plane.\n*   `customError` (*type:* `GoogleApi.ServiceNetworking.V1.Model.CustomError.t`, *default:* `nil`) - Custom error configuration.\n*   `documentation` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Documentation.t`, *default:* `nil`) - Additional API documentation.\n*   `endpoints` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Endpoint.t)`, *default:* `nil`) - Configuration for network endpoints. If this is empty, then an endpoint with the same name as the service is automatically generated to service all defined APIs.\n*   `enums` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Enum.t)`, *default:* `nil`) - A list of all enum types included in this API service. Enums referenced directly or indirectly by the `apis` are automatically included. Enums which are not referenced but shall be included should be listed here by name by the configuration author. Example: enums: - name: google.someapi.v1.SomeEnum\n*   `http` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Http.t`, *default:* `nil`) - HTTP configuration.\n*   `id` (*type:* `String.t`, *default:* `nil`) - A unique ID for a specific instance of this message, typically assigned by the client for tracking purpose. Must be no longer than 63 characters and only lower case letters, digits, '.', '_' and '-' are allowed. If empty, the server may choose to generate one instead.\n*   `logging` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Logging.t`, *default:* `nil`) - Logging configuration.\n*   `logs` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.LogDescriptor.t)`, *default:* `nil`) - Defines the logs used by this service.\n*   `metrics` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.MetricDescriptor.t)`, *default:* `nil`) - Defines the metrics used by this service.\n*   `monitoredResources` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.MonitoredResourceDescriptor.t)`, *default:* `nil`) - Defines the monitored resources used by this service. This is required by the Service.monitoring and Service.logging configurations.\n*   `monitoring` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Monitoring.t`, *default:* `nil`) - Monitoring configuration.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The service name, which is a DNS-like logical identifier for the service, such as `calendar.googleapis.com`. The service name typically goes through DNS verification to make sure the owner of the service also owns the DNS name.\n*   `producerProjectId` (*type:* `String.t`, *default:* `nil`) - The Google project that owns this service.\n*   `publishing` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Publishing.t`, *default:* `nil`) - Settings for [Google Cloud Client libraries](https://cloud.google.com/apis/docs/cloud-client-libraries) generated from APIs defined as protocol buffers.\n*   `quota` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Quota.t`, *default:* `nil`) - Quota configuration.\n*   `sourceInfo` (*type:* `GoogleApi.ServiceNetworking.V1.Model.SourceInfo.t`, *default:* `nil`) - Output only. The source information for this configuration if available.\n*   `systemParameters` (*type:* `GoogleApi.ServiceNetworking.V1.Model.SystemParameters.t`, *default:* `nil`) - System parameter configuration.\n*   `systemTypes` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Type.t)`, *default:* `nil`) - A list of all proto message types included in this API service. It serves similar purpose as [google.api.Service.types], except that these types are not needed by user-defined APIs. Therefore, they will not show up in the generated discovery doc. This field should only be used to define system APIs in ESF.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The product title for this service, it is the name displayed in Google Cloud Console.\n*   `types` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Type.t)`, *default:* `nil`) - A list of all proto message types included in this API service. Types referenced directly or indirectly by the `apis` are automatically included. Messages which are not referenced but shall be included, such as types used by the `google.protobuf.Any` type, should be listed here by name by the configuration author. Example: types: - name: google.protobuf.Int32\n*   `usage` (*type:* `GoogleApi.ServiceNetworking.V1.Model.Usage.t`, *default:* `nil`) - Configuration controlling usage of this service.","ref":"GoogleApi.ServiceNetworking.V1.Model.Service.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Service.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Service.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Service.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Service.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SourceContext","doc":"`SourceContext` represents information about the source of a protobuf element, like the file in which it is defined.","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceContext.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SourceContext","doc":"*   `fileName` (*type:* `String.t`, *default:* `nil`) - The path-qualified name of the .proto file that contained the associated protobuf element. For example: `\"google/protobuf/source_context.proto\"`.","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceContext.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SourceContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceContext.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SourceContext.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceContext.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SourceInfo","doc":"Source information used to create a Service Config","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceInfo.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SourceInfo","doc":"*   `sourceFiles` (*type:* `list(map())`, *default:* `nil`) - All files used during config generation.","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SourceInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceInfo.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SourceInfo.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SourceInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Status","doc":"The `Status` type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by [gRPC](https://github.com/grpc). Each `Status` message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the [API Design Guide](https://cloud.google.com/apis/design/errors).","ref":"GoogleApi.ServiceNetworking.V1.Model.Status.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Status","doc":"*   `code` (*type:* `integer()`, *default:* `nil`) - The status code, which should be an enum value of google.rpc.Code.\n*   `details` (*type:* `list(map())`, *default:* `nil`) - A list of messages that carry the error details. There is a common set of message types for APIs to use.\n*   `message` (*type:* `String.t`, *default:* `nil`) - A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.","ref":"GoogleApi.ServiceNetworking.V1.Model.Status.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Status.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Status.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Status.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Status.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Subnetwork","doc":"Represents a subnet that was created or discovered by a private access management service.","ref":"GoogleApi.ServiceNetworking.V1.Model.Subnetwork.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Subnetwork","doc":"*   `ipCidrRange` (*type:* `String.t`, *default:* `nil`) - Subnetwork CIDR range in `10.x.x.x/y` format.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Subnetwork name. See https://cloud.google.com/compute/docs/vpc/\n*   `network` (*type:* `String.t`, *default:* `nil`) - In the Shared VPC host project, the VPC network that's peered with the consumer network. For example: `projects/1234321/global/networks/host-network`\n*   `outsideAllocation` (*type:* `boolean()`, *default:* `nil`) - This is a discovered subnet that is not within the current consumer allocated ranges.\n*   `region` (*type:* `String.t`, *default:* `nil`) - GCP region where the subnetwork is located.\n*   `secondaryIpRanges` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.SecondaryIpRange.t)`, *default:* `nil`) - List of secondary IP ranges in this subnetwork.","ref":"GoogleApi.ServiceNetworking.V1.Model.Subnetwork.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Subnetwork.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Subnetwork.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Subnetwork.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Subnetwork.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameter","doc":"Define a parameter's name and location. The parameter may be passed as either an HTTP header or a URL query parameter, and if both are passed the behavior is implementation-dependent.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameter.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SystemParameter","doc":"*   `httpHeader` (*type:* `String.t`, *default:* `nil`) - Define the HTTP header name to use for the parameter. It is case insensitive.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Define the name of the parameter, such as \"api_key\" . It is case sensitive.\n*   `urlQueryParameter` (*type:* `String.t`, *default:* `nil`) - Define the URL query parameter name to use for the parameter. It is case sensitive.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameter.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameter.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameter.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameter.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameter.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule","doc":"Define a system parameter rule mapping system parameter definitions to methods.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule","doc":"*   `parameters` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.SystemParameter.t)`, *default:* `nil`) - Define parameters. Multiple names may be defined for a parameter. For a given method call, only one of them should be used. If multiple names are used the behavior is implementation-dependent. If none of the specified names are present the behavior is parameter-dependent.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Use '*' to indicate all methods in all APIs. Refer to selector for syntax details.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters.html"},{"type":"module","title":"System parameter configuration A system parameter is a special kind of parameter defined by the API system, not by an individual API. It is typically mapped to an HTTP header and/or a URL query parameter. This configuration specifies which methods change the names of the system parameters. - GoogleApi.ServiceNetworking.V1.Model.SystemParameters","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters.html#module-system-parameter-configuration-a-system-parameter-is-a-special-kind-of-parameter-defined-by-the-api-system-not-by-an-individual-api-it-is-typically-mapped-to-an-http-header-and-or-a-url-query-parameter-this-configuration-specifies-which-methods-change-the-names-of-the-system-parameters"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.SystemParameters","doc":"*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.SystemParameterRule.t)`, *default:* `nil`) - Define system parameters. The parameters defined here will override the default parameters implemented by the system. If this field is missing from the service config, default system parameters will be used. Default system parameters and names is implementation-dependent. Example: define api key for all methods system_parameters rules: - selector: \"*\" parameters: - name: api_key url_query_parameter: api_key Example: define 2 api key names for a specific method. system_parameters rules: - selector: \"/ListShelves\" parameters: - name: api_key http_header: Api-Key1 - name: api_key http_header: Api-Key2 **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.SystemParameters.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Type","doc":"A protocol buffer message type.","ref":"GoogleApi.ServiceNetworking.V1.Model.Type.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Type","doc":"*   `edition` (*type:* `String.t`, *default:* `nil`) - The source edition string, only valid when syntax is SYNTAX_EDITIONS.\n*   `fields` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Field.t)`, *default:* `nil`) - The list of fields.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The fully qualified message name.\n*   `oneofs` (*type:* `list(String.t)`, *default:* `nil`) - The list of types appearing in `oneof` definitions in this type.\n*   `options` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Option.t)`, *default:* `nil`) - The protocol buffer options.\n*   `sourceContext` (*type:* `GoogleApi.ServiceNetworking.V1.Model.SourceContext.t`, *default:* `nil`) - The source context.\n*   `syntax` (*type:* `String.t`, *default:* `nil`) - The source syntax.","ref":"GoogleApi.ServiceNetworking.V1.Model.Type.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Type.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Type.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Type.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Type.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest","doc":"Request to update the configuration of a service networking connection including the import/export of custom routes and subnetwork routes with public IP.","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest","doc":"*   `consumerConfig` (*type:* `GoogleApi.ServiceNetworking.V1.Model.ConsumerConfig.t`, *default:* `nil`) - Required. The updated peering config.","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateConsumerConfigRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata","doc":"Metadata provided through GetOperation request for the LRO generated by UpdateDnsRecordSet API","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest","doc":"Request to update a record set from a private managed DNS zone in the shared producer host project. The name, type, ttl, and data values of the existing record set must all exactly match an existing record set in the specified zone.","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest","doc":"*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is the project number, as in '12345' {network} is the network name.\n*   `existingDnsRecordSet` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.t`, *default:* `nil`) - Required. The existing DNS record set to update.\n*   `newDnsRecordSet` (*type:* `GoogleApi.ServiceNetworking.V1.Model.DnsRecordSet.t`, *default:* `nil`) - Required. The new values that the DNS record set should be updated to hold.\n*   `zone` (*type:* `String.t`, *default:* `nil`) - Required. The name of the private DNS zone in the shared producer host project from which the record set will be removed.","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.UpdateDnsRecordSetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.Usage","doc":"Configuration controlling usage of a service.","ref":"GoogleApi.ServiceNetworking.V1.Model.Usage.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.Usage","doc":"*   `producerNotificationChannel` (*type:* `String.t`, *default:* `nil`) - The full resource name of a channel used for sending notifications to the service producer. Google Service Management currently only supports [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification channel. To use Google Cloud Pub/Sub as the channel, this must be the name of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format documented in https://cloud.google.com/pubsub/docs/overview.\n*   `requirements` (*type:* `list(String.t)`, *default:* `nil`) - Requirements that must be satisfied before a consumer project can use the service. Each requirement is of the form /; for example 'serviceusage.googleapis.com/billing-enabled'. For Google APIs, a Terms of Service requirement must be included here. Google Cloud APIs must include \"serviceusage.googleapis.com/tos/cloud\". Other Google APIs should include \"serviceusage.googleapis.com/tos/universal\". Additional ToS can be included based on the business needs.\n*   `rules` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.UsageRule.t)`, *default:* `nil`) - A list of usage rules that apply to individual API methods. **NOTE:** All service configuration rules follow \"last one wins\" order.","ref":"GoogleApi.ServiceNetworking.V1.Model.Usage.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.Usage.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.Usage.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.Usage.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.Usage.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.UsageRule","doc":"Usage configuration rules for the service. NOTE: Under development. Use this rule to configure unregistered calls for the service. Unregistered calls are calls that do not contain consumer project identity. (Example: calls that do not contain an API key). By default, API methods do not allow unregistered calls, and each method call must be identified by a consumer project identity. Use this rule to allow/disallow unregistered calls. Example of an API that wants to allow unregistered calls for entire service. usage: rules: - selector: \"*\" allow_unregistered_calls: true Example of a method that wants to allow unregistered calls. usage: rules: - selector: \"google.example.library.v1.LibraryService.CreateBook\" allow_unregistered_calls: true","ref":"GoogleApi.ServiceNetworking.V1.Model.UsageRule.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.UsageRule","doc":"*   `allowUnregisteredCalls` (*type:* `boolean()`, *default:* `nil`) - If true, the selected method allows unregistered calls, e.g. calls that don't identify any user or application.\n*   `selector` (*type:* `String.t`, *default:* `nil`) - Selects the methods to which this rule applies. Use '*' to indicate all methods in all APIs. Refer to selector for syntax details.\n*   `skipServiceControl` (*type:* `boolean()`, *default:* `nil`) - If true, the selected method should skip service control and the control plane features, such as quota and billing, will not be available. This flag is used by Google Cloud Endpoints to bypass checks for internal methods, such as service health check methods.","ref":"GoogleApi.ServiceNetworking.V1.Model.UsageRule.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.UsageRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.UsageRule.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.UsageRule.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.UsageRule.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest","doc":"*   `checkServiceNetworkingUsePermission` (*type:* `boolean()`, *default:* `nil`) - Optional. The IAM permission check determines whether the consumer project has 'servicenetworking.services.use' permission or not.\n*   `consumerNetwork` (*type:* `String.t`, *default:* `nil`) - Required. The network that the consumer is using to connect with services. Must be in the form of projects/{project}/global/networks/{network} {project} is a project number, as in '12345' {network} is network name.\n*   `consumerProject` (*type:* `GoogleApi.ServiceNetworking.V1.Model.ConsumerProject.t`, *default:* `nil`) - NETWORK_NOT_IN_CONSUMERS_PROJECT, NETWORK_NOT_IN_CONSUMERS_HOST_PROJECT, and HOST_PROJECT_NOT_FOUND are done when consumer_project is provided.\n*   `rangeReservation` (*type:* `GoogleApi.ServiceNetworking.V1.Model.RangeReservation.t`, *default:* `nil`) - RANGES_EXHAUSTED, RANGES_EXHAUSTED, and RANGES_DELETED_LATER are done when range_reservation is provided.\n*   `validateNetwork` (*type:* `boolean()`, *default:* `nil`) - The validations will be performed in the order listed in the ValidationError enum. The first failure will return. If a validation is not requested, then the next one will be performed. SERVICE_NETWORKING_NOT_ENABLED and NETWORK_NOT_PEERED checks are performed for all requests where validation is requested. NETWORK_NOT_FOUND and NETWORK_DISCONNECTED checks are done for requests that have validate_network set to true.","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse","doc":"*   `existingSubnetworkCandidates` (*type:* `list(GoogleApi.ServiceNetworking.V1.Model.Subnetwork.t)`, *default:* `nil`) - List of subnetwork candidates from the request which exist with the `ip_cidr_range`, `secondary_ip_cider_ranges`, and `outside_allocation` fields set.\n*   `isValid` (*type:* `boolean()`, *default:* `nil`) - Indicates whether all the requested validations passed.\n*   `validationError` (*type:* `String.t`, *default:* `nil`) - The first validation which failed.","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.ValidateConsumerConfigResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls","doc":"Response for the get VPC Service Controls request.","ref":"GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls.html"},{"type":"module","title":"Attributes - GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls","doc":"*   `enabled` (*type:* `boolean()`, *default:* `nil`) - Output only. Indicates whether the VPC Service Controls are enabled or disabled for the connection. If the consumer called the EnableVpcServiceControls method, then this is true. If the consumer called DisableVpcServiceControls, then this is false. The default is false.","ref":"GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls.html#module-attributes"},{"type":"function","title":"GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls.html#decode/2"},{"type":"type","title":"GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls.t/0","doc":"","ref":"GoogleApi.ServiceNetworking.V1.Model.VpcServiceControls.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}